<!DOCTYPE HTML>
<%@ page contentType="text/html; charset=utf-8"%>
<%@ taglib prefix="s" uri="/struts-tags"%>
<html>
<head>
<META name="decorator" content="<s:property value="decorator"/>">
</head>
<script type="text/javascript">
	function setLanguage(lang){
		$('#language').val(lang);
		if(lang == 'ca_ES'){
			$('#titol').val("<s:property value='%{producte.getTitol(\"ca_ES\")}'/>");
			$('#descripcio').html("<s:property value='%{producte.getDescripcio(\"ca_ES\")}'/>");
			$('#descripcio').htmlarea('updateHtmlArea');
		}else if(lang == 'es_ES'){
			$('#titol').val("<s:property value='%{producte.getTitol(\"es_ES\")}'/>");
			$('#descripcio').html("<s:property value='%{producte.getDescripcio(\'es_ES\')}'/>");
			$('#descripcio').htmlarea('updateHtmlArea');
		}else if(lang == 'en_GB'){
			$('#titol').val("<s:property value='%{producte.getTitol(\"en_GB\")}'/>");
			$('#descripcio').html("<s:property value='%{producte.getDescripcio(\"en_GB\")}'/>");
			$('#descripcio').htmlarea('updateHtmlArea');
		}
	}
	
	$(document).ready(function(){
		$('#descripcio').htmlarea({
			toolbar: [
			          ["html"],
			          ["bold", "italic", "underline"],
			          ["h1", "h2", "h3", "h4", "h5", "h6"],
			          ["link", "unlink"],
			          ["increasefontsize", "decreasefontsize", "superscript", "subscript"],
			          ["orderedList", "unorderedList", "indent", "outdent", "image"]
			      ]
			  });
		
		$('#fileupload').submit(function() {
			var ref = $('#fileupload input[name="ref"]');
			var titol = $('#fileupload input[name="titol"]');
			var descripcio = $('#fileupload textarea[name="descripcio"]');
			var stock = $('#fileupload input[name="stock"]');
			var preu = $('#fileupload input[name="preu"]');
			var pes = $('#fileupload input[name="pes"]');
			var categoria = $('#fileupload select[name="categoriaId"]');
			var colors = $('#fileupload select[name="colorsDisponibles"] option:selected');
			var errors = $('#errors');
			var error = false;
			
			if(jQuery.trim(ref.val()) == ""){
				errors.append('<s:text name="backoffice.edit.producte.ref.missing"/><br/>');
				error = true;
			}
			if(jQuery.trim(titol.val()) == ""){
				errors.append('<s:text name="backoffice.edit.producte.titol.missing"/><br/>');
				error = true;
			}
			if(jQuery.trim(descripcio.val()) == ""){
				errors.append('<s:text name="backoffice.edit.producte.descripcio.missing"/><br/>');
				error = true;
			}
			if(jQuery.trim(stock.val()) == ""){
				errors.append('<s:text name="backoffice.edit.producte.stock.missing"/><br/>');
				error = true;
			}
			if(jQuery.trim(preu.val()) == "0.0" || jQuery.trim(preu.val()) == "0"){
				errors.append('<s:text name="backoffice.edit.producte.preu.missing"/><br/>');
				error = true;
			}
			if(jQuery.trim(pes.val()) == ""){
				errors.append('<s:text name="backoffice.edit.producte.pes.missing"/><br/>');
				error = true;
			}
			if(categoria.val() == -1){
				errors.append('<s:text name="backoffice.edit.producte.categoria.missing"/><br/>');
				error = true;
			}
			if(colors.size() == 0){
				errors.append('<s:text name="backoffice.edit.producte.colors.missing"/><br/>');
				error = true;
			}
			if(error){
				errors.show();
				return false;
			}
		});
	});
</script>
<body>
	<div class="container">
		<div class="languagesDiv">
			<ul class="languageEdit">
				<li><a onclick="setLanguage('en_GB')" href="#"><s:text name="back.language.angles"/></a></li>
				<li><a onclick="setLanguage('es_ES')" href="#"><s:text name="back.language.castella"/></a></li>
				<li><a onclick="setLanguage('ca_ES')" href="#"><s:text name="back.language.catala"/></a></li>
			</ul>
		</div>
		<div id="errors">
		</div>
		<s:form id="fileupload" action="save" namespace="/backoffice/product" method="POST" enctype="multipart/form-data">
			
			<s:hidden name="producteId" value="%{producte.id}" id="productId"></s:hidden>
			<s:hidden name="language" value="ca_ES" id="language"></s:hidden>
			<s:textfield key="backoffice.edit.producte.ref" name="ref"
				value="%{producte.ref}"></s:textfield>
			<s:textfield key="backoffice.edit.producte.titol" name="titol"
				value="%{producte.getTitol('ca_ES')}" id="titol" cssClass="producteTitol"></s:textfield>
			<s:textarea key="backoffice.edit.producte.descripcio"
				name="descripcio" value="%{producte.getDescripcio('ca_ES')}" cols="50" rows="5" id="descripcio"></s:textarea>
			<s:textfield key="backoffice.edit.producte.stock" name="stock"
				value="%{producte.stock}"></s:textfield>
			<s:textfield key="backoffice.edit.producte.preu" name="preu"
				value="%{producte.preu}"></s:textfield>
			<s:textfield key="backoffice.edit.producte.pes" name="pes"
				value="%{producte.pes}"></s:textfield>
			<s:select list="categories" listKey="id" listValue="descripcio"
				headerKey="-1" headerValue="Trii una categoria" name="categoriaId" 
				key="backoffice.edit.producte.categoria" value="%{producte.categories.id}"></s:select>
			<s:select list="colors" listKey="id" listValue="descripcio"
				multiple="true" name="colorsDisponibles" key="backoffice.edit.producte.color"
				value="%{selectedColors.{id}}"></s:select>
			<s:select list="promocions" listKey="id" listValue="descripcio"
				multiple="true" name="promocionsDisponibles" key="backoffice.edit.producte.promocions"
				value="%{promocionsSelected.{id}}"></s:select>
			<s:textfield key="backoffice.edit.producte.pare" value="%{producte.producte.ref}" name="productePare"/>
			<s:file key="back.home.productes.edit.imatge1" name="imatge1" id="imatge1"></s:file>
			<s:file key="back.home.productes.edit.imatge2" name="imatge2" id="imatge2"></s:file>
			<s:file key="back.home.productes.edit.imatge3" name="imatge3" id="imatge3"></s:file>
		</s:form>
		<div class="images">
			<s:if test="%{producte.imatge1 != null && producte.imatge1.trim().length() > 0}">
				<s:url value="%{producte.imatge1}" var="img1URL"/>
				<img src="<s:property value='#img1URL'/>"/>
			</s:if>
			<s:if test="%{producte.imatge2 != null && producte.imatge2.trim().length() > 0}">
				<s:url value="%{producte.imatge2}" var="img2URL"/>
				<img src="<s:property value='#img2URL'/>"/>
			</s:if>
			<s:if test="%{producte.imatge3 != null && producte.imatge3.trim().length() > 0}">
				<s:url value="%{producte.imatge3}" var="img3URL"/>
				<img src="<s:property value='#img3URL'/>"/>
			</s:if>
		</div>
		<div class="submitButtonsProducte">
			<span><a onclick="$('#fileupload').submit()" href="#" class="buttonLike"><s:text name="back.home.global.save"/></a></span>
			<s:a action="list" namespace="/backoffice/product" cssClass="buttonLike"><s:text name="back.global.cancela"/></s:a>
		</div>
	</div>
</body>
</html>
