package com.selya.store.back.action;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import com.selya.store.global.action.BaseAction;
import com.selya.store.persistance.Carreto;
import com.selya.store.persistance.CarretoDAO;
import com.selya.store.persistance.Carretoproducte;
import com.selya.store.persistance.CarretoproducteDAO;
import com.selya.store.persistance.Estatcarreto;
import com.selya.store.persistance.EstatcarretoDAO;
import com.selya.store.persistance.Usuaris;
import com.selya.store.persistance.UsuarisDAO;

public class ComandesAction extends BaseAction {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -2277974906412192119L;
	
	private Carreto comanda;
	private Set<Carreto> comandes;
	private List<Estatcarreto> estats;
	
	private int estat;
	private String username;
	private long comandaId;
	private List<Carretoproducte> productes;
	

	@Override
	public void prepare() throws Exception {
		super.prepare();
	}
	
	@SuppressWarnings("unchecked")
	public String list(){
		
		CarretoDAO carretoDAO = new CarretoDAO();
		List<Carreto> comandes = carretoDAO.findAll();
		comandes = getResultsByPage(comandes);
		this.comandes = new HashSet<Carreto>(comandes);
		
		
		return SUCCESS;
	}
	
	@SuppressWarnings("unchecked")
	public String search(){
		
		UsuarisDAO uDAO = new UsuarisDAO();
		List<Usuaris> usuaris = uDAO.findByUsuari(username);
		if(usuaris.size() > 0){
			Usuaris usuari = usuaris.get(0);
			if(estat > 0){
				comandes = usuari.getCarretos();
			}else{
				comandes = new HashSet<Carreto>();
			}
			
		}else if(estat > 0){
			CarretoDAO cDAO = new CarretoDAO();
			EstatcarretoDAO eDAO = new EstatcarretoDAO();
			comandes = new HashSet<Carreto>(cDAO.findByProperty("estat", eDAO.findById(estat)));
		}else if(comandaId > 0){
			comandes = new HashSet<Carreto>();
			CarretoDAO cDAO = new CarretoDAO();
			comandes.add(cDAO.findById(comandaId));
		}else{
			list();
		}
		
		return SUCCESS;
	}
	
	@SuppressWarnings("unchecked")
	public String edit(){
		
		CarretoDAO cDAO = new CarretoDAO();
		comanda = cDAO.findById(comandaId);
		EstatcarretoDAO ecDAO = new EstatcarretoDAO();
		estats = ecDAO.findAll();
		return SUCCESS;
	}
	
	public String save(){
		CarretoDAO cDAO = new CarretoDAO();
		comanda = cDAO.findById(comandaId);
		EstatcarretoDAO estatcarretoDAO = new EstatcarretoDAO();
		comanda.setEstatcarreto(estatcarretoDAO.findById(estat));
		cDAO.merge(comanda);		
		return SUCCESS;
	}
	
	@SuppressWarnings("unchecked")
	public List<Carretoproducte> generateProducteCarreto(long carretoId){
		CarretoproducteDAO cpDAO = new CarretoproducteDAO();
		return cpDAO.findByProperty("carretoid", carretoId);
	}
	
	public int getEstat() {
		return estat;
	}

	public void setEstat(int estat) {
		this.estat = estat;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public long getComandaId() {
		return comandaId;
	}

	public void setComandaId(long comandaId) {
		this.comandaId = comandaId;
	}

	public Carreto getComanda() {
		return comanda;
	}

	public void setComanda(Carreto comanda) {
		this.comanda = comanda;
	}

	/**
	 * @return the estats
	 */
	public List<Estatcarreto> getEstats() {
		return estats;
	}

	/**
	 * @param estats the estats to set
	 */
	public void setEstats(List<Estatcarreto> estats) {
		this.estats = estats;
	}

	public Set<Carreto> getComandes() {
		return comandes;
	}

	public void setComandes(Set<Carreto> comandes) {
		this.comandes = comandes;
	}

	public List<Carretoproducte> getProductes() {
		return productes;
	}

	public void setProductes(List<Carretoproducte> productes) {
		this.productes = productes;
	}

	public int getEstatCarreto() {
		return estat;
	}

	public void setEstatCarreto(int estatCarreto) {
		this.estat = estatCarreto;
	}

}
