package com.selya.store.back.action;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.selya.store.global.action.BaseAction;
import com.selya.store.global.beans.KeyValue;
import com.selya.store.persistance.BaseHibernateDAO;

public class EstadistiquesAction extends BaseAction {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 9088295856259952788L;
	private List<KeyValue> keyValue;
	private int staticsClass;
	
	@Override
	public void prepare() throws Exception {
		super.prepare();
		keyValue = new ArrayList<KeyValue>();
	}
	
	@SuppressWarnings("unchecked")
	public String usuaris(){
		
		BaseHibernateDAO bDAO = new BaseHibernateDAO();
		String sql = "select u.Usuari as usuari, count(c.Id) as num from usuaris u" +
					" inner join carreto c on c.UsuariId = u.Id and c.EstatId > 2" +
					" order by num desc";
		
		Iterator<Object[]> it = bDAO.getSession().createSQLQuery(sql).list().iterator();
		while(it.hasNext()){
			Object[] obj = it.next();
			keyValue.add(new KeyValue(obj[0].toString(), Integer.parseInt(obj[1].toString())));
		}
		
		staticsClass = 1;
		
		return SUCCESS;
	}
	
	
	@SuppressWarnings("unchecked")
	public String comandes(){
		
		BaseHibernateDAO bDAO = new BaseHibernateDAO();
		String sql = "select CONCAT(MONTH(DataModificacio),'/',YEAR(DataModificacio)) as mes, count(Id) as carretons from carreto where EstatId > 2 group by MONTH(DataModificacio)";
		
		Iterator<Object[]> it = bDAO.getSession().createSQLQuery(sql).list().iterator();
		while(it.hasNext()){
			Object[] obj = it.next();
			keyValue.add(new KeyValue(obj[0].toString(), Integer.parseInt(obj[1].toString())));
		}
		
		staticsClass = 2;
		
		return SUCCESS;
	}
	
	
	@SuppressWarnings("unchecked")
	public String productes(){
		
		BaseHibernateDAO bDAO = new BaseHibernateDAO();
		String sql = "select p.Ref as ref, sum(cp.quantitat) as quantitat from producte p " +
					"inner join carretoproducte cp on cp.ProducteId = p.Id " +
					"inner join carreto c on c.Id = cp.CarretoId and c.EstatId > 2 " +
					"group by cp.ProducteId order by quantitat desc";
		
		Iterator<Object[]> it = bDAO.getSession().createSQLQuery(sql).list().iterator();
		while(it.hasNext()){
			Object[] obj = it.next();
			keyValue.add(new KeyValue(obj[0].toString(), Integer.parseInt(obj[1].toString())));
		}
		
		staticsClass = 3;
		
		return SUCCESS;
	}

	public List<KeyValue> getKeyValue() {
		return keyValue;
	}

	public void setKeyValue(List<KeyValue> keyValue) {
		this.keyValue = keyValue;
	}

	public int getStaticsClass() {
		return staticsClass;
	}

	public void setStaticsClass(int staticsClass) {
		this.staticsClass = staticsClass;
	}

}
