package com.selya.store.back.action;

import java.util.List;

import com.selya.store.global.action.BaseAction;
import com.selya.store.persistance.Carreto;
import com.selya.store.persistance.CarretoDAO;
import com.selya.store.persistance.Comentaris;
import com.selya.store.persistance.ComentarisDAO;
import com.selya.store.persistance.EstatcarretoDAO;

public class LastNewsAction extends BaseAction {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6174750561442491951L;
	private static final int ESTAT_PAGAT = 3;
	private List<Comentaris> comentaris;
	private List<Carreto> comandes;
	
	@SuppressWarnings("unchecked")
	@Override
	public String execute() throws Exception {
		
		if(getUser() == null){
			return ERROR;
		}
		
		ComentarisDAO comentarisDAO = new ComentarisDAO();
		comentaris = comentarisDAO.lastComments();
		
		CarretoDAO cDAO = new CarretoDAO();
		EstatcarretoDAO estatDAO = new EstatcarretoDAO();
		comandes = cDAO.findByProperty("estatcarreto", estatDAO.findById(ESTAT_PAGAT));
		
		return SUCCESS;
	}


	/**
	 * @return the comentaris
	 */
	public List<Comentaris> getComentaris() {
		return comentaris;
	}


	/**
	 * @param comentaris the comentaris to set
	 */
	public void setComentaris(List<Comentaris> comentaris) {
		this.comentaris = comentaris;
	}


	/**
	 * @return the comandes
	 */
	public List<Carreto> getComandes() {
		return comandes;
	}


	/**
	 * @param comandes the comandes to set
	 */
	public void setComandes(List<Carreto> comandes) {
		this.comandes = comandes;
	}
	
}
