package com.selya.store.back.action;

import com.selya.store.global.action.BaseAction;
import com.selya.store.global.utils.Globals;
import com.selya.store.persistance.Usuaris;
import com.selya.store.persistance.UsuarisDAO;

/**
 * 
 * @author Daniel Martín
 *
 */
public class LoginAction extends BaseAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = 7007020479108324005L;
	
	private String username;
	private String password;
	
	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public String login() throws Exception {
		UsuarisDAO userDAO = new UsuarisDAO();
		Usuaris usuari = userDAO.loginUser(username, password);
		
		if(usuari != null && usuari.getAdmin() == Globals.ADMIN){
			setUser(usuari);
			return SUCCESS;
		}
		
		addActionError(getText("login.error"));
		return ERROR;
	}
	
	public String logout(){
		getRequest().getSession().setAttribute("user", null);
		initUser(true);
		return SUCCESS;
	}
	
}
