package com.selya.store.back.action;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.apache.commons.io.FileUtils;

import com.selya.store.global.action.BaseAction;
import com.selya.store.global.utils.StringUtils;
import com.selya.store.persistance.Categories;
import com.selya.store.persistance.CategoriesDAO;
import com.selya.store.persistance.Color;
import com.selya.store.persistance.ColorDAO;
import com.selya.store.persistance.Producte;
import com.selya.store.persistance.ProducteDAO;
import com.selya.store.persistance.Productecolor;
import com.selya.store.persistance.ProductecolorDAO;
import com.selya.store.persistance.ProductecolorId;
import com.selya.store.persistance.Productepromocio;
import com.selya.store.persistance.ProductepromocioDAO;
import com.selya.store.persistance.ProductepromocioId;
import com.selya.store.persistance.Promocio;
import com.selya.store.persistance.PromocioDAO;

/**
 * 
 * @author Daniel Martín
 *
 */
public class ProducteAction extends BaseAction {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6972325586207888882L;
	
	private List<Producte> productes;
	private Producte producte;
	private List<com.selya.store.global.beans.Categories> categories;
	private List<com.selya.store.global.beans.Color> colors;
	private List<com.selya.store.global.beans.Color> selectedColors;
	private List<Promocio> promocions;
	private List<Promocio> promocionsSelected;
	private String language;
	
	private String colorsDisponibles;
	
	private static final String SERVERIMAGEPATH = "/resources/images/products/";
	private static final String IMG1 = "/imatge1.jpg";
	private static final String IMG2 = "/imatge2.jpg";
	private static final String IMG3 = "/imatge3.jpg";
	
	/* camps de Producte */
	private long producteId;
	private String ref;
	private String titol;
	private String descripcio;
	private float preu;
	private int stock;
	private File imatge1;
	private File imatge2;
	private File imatge3;
	private Date data;
	private int categoriaId;
	private String productePare;
	private int pes;
	private String promocionsDisponibles;
	
	
	@SuppressWarnings("unchecked")
	@Override
	public void prepare() throws Exception {
		ColorDAO colorDAO = new ColorDAO();
	    colors = colorDAO.findAll();
	    CategoriesDAO categoriesDAO = new CategoriesDAO();
	    categories = categoriesDAO.findAll();
		super.prepare();
	}
	
	@SuppressWarnings("unchecked")
	public String list(){
		productes = new ArrayList<Producte>();
		ProducteDAO pDAO = new ProducteDAO();
		List<Producte> products = pDAO.findAll();
		Iterator<Producte> it = products.iterator();
		List<Color> colors = new ArrayList<Color>();
		while(it.hasNext()){
			Producte product = it.next();
			ProductecolorDAO producteColorDAO = new ProductecolorDAO();
			List<Productecolor> producteColor = producteColorDAO.findByProperty("producte", product);
			Iterator<Productecolor> itProducteColor = producteColor.iterator();
			while(itProducteColor.hasNext()){
				colors.add(itProducteColor.next().getColor());
			}

			productes.add(product);
		}
		productes = getResultsByPage(productes);
		
		return SUCCESS;
	}
	
	@SuppressWarnings("unchecked")
	public String search(){
		productes = new ArrayList<Producte>();
		ProducteDAO pDAO  =new ProducteDAO();
		if(StringUtils.isNotNull(ref)){
			List<Producte> prod = pDAO.findByRef(ref);
			if(prod.size() > 0)
				productes.add(prod.get(0));
		}else if(categoriaId > 0){
			CategoriesDAO categoriesDAO = new CategoriesDAO();
			List<Producte> productes = pDAO.findByProperty("categories", categoriesDAO.findById(categoriaId));
			Iterator<Producte> it = productes.iterator();
			while(it.hasNext())
				this.productes.add(it.next());
		}else{
			 list();
		}
		
		return SUCCESS;
		
	}
	
	@SuppressWarnings("unchecked")
	public String edit(){
		ProducteDAO producteDAO = new ProducteDAO();
		List<Producte> productesList = producteDAO.findByRef(ref);
		if(productesList != null && productesList.size() > 0){
			producte = productesList.get(0);
			ColorDAO colorsDAO = new ColorDAO();
			Iterator<Color> itColors = colorsDAO.findAll().iterator();
			this.colors = new ArrayList<com.selya.store.global.beans.Color>();
			while(itColors.hasNext()){
				Color color = itColors.next();
				this.colors.add(new com.selya.store.global.beans.Color(color.getId(),color.getDescripcio("ca_ES")));
			}
			selectedColors = new ArrayList<com.selya.store.global.beans.Color>();
			Iterator<Productecolor> itSelectedColors = producte.getProductecolors().iterator();
			while(itSelectedColors.hasNext()){
				Color color = itSelectedColors.next().getColor();
				this.selectedColors.add(new com.selya.store.global.beans.Color(color.getId(),color.getDescripcio("ca_ES")));
			}
			
		    CategoriesDAO categoriesDAO = new CategoriesDAO();
		    Iterator<Categories> itCateg = categoriesDAO.findAll().iterator();
		    this.categories = new ArrayList<com.selya.store.global.beans.Categories>();
		    while(itCateg.hasNext()){
		    	Categories categoria = itCateg.next();
		    	this.categories.add(new com.selya.store.global.beans.Categories(categoria.getId(), categoria.getDescripcio("ca_ES")));
		    }
		    
		    PromocioDAO promocioDAO = new PromocioDAO();
		    promocions = promocioDAO.findAll();
		    promocionsSelected = new ArrayList<Promocio>();
		    Iterator<Productepromocio> itPromocio = producte.getProductepromocios().iterator();
		    while(itPromocio.hasNext()){
		    	promocionsSelected.add(itPromocio.next().getPromocio());
		    }
			return SUCCESS;
		}
		return ERROR;
	}
	
	@SuppressWarnings("unchecked")
	public String newProduct(){
		producte = new Producte();
		ColorDAO colorsDAO = new ColorDAO();
		Iterator<Color> itColors = colorsDAO.findAll().iterator();
		this.colors = new ArrayList<com.selya.store.global.beans.Color>();
		while(itColors.hasNext()){
			Color color = itColors.next();
			this.colors.add(new com.selya.store.global.beans.Color(color.getId(),color.getDescripcio("ca_ES")));
		}
	    CategoriesDAO categoriesDAO = new CategoriesDAO();
	    Iterator<Categories> itCateg = categoriesDAO.findAll().iterator();
	    this.categories = new ArrayList<com.selya.store.global.beans.Categories>();
	    while(itCateg.hasNext()){
	    	Categories categoria = itCateg.next();
	    	this.categories.add(new com.selya.store.global.beans.Categories(categoria.getId(), categoria.getDescripcio("ca_ES")));
	    }
	    
	    PromocioDAO promocioDAO = new PromocioDAO();
	    promocions = promocioDAO.findAll();

	    return SUCCESS;
	}
	
	public String save(){
		ProducteDAO producteDAO = new ProducteDAO();

		if(producteId > 0){
			producte = producteDAO.findById(producteId);
		}else{
			producte = new Producte();
		}
		
		producte.setRef(ref);
		producte.setTitol(language, titol);
		producte.setDescripcio(language, descripcio);
		producte.setData(data);
		producte.setPreu(preu);
		producte.setStock(stock);
		producte.setPes(pes);
		
		try {
			String realpath = getRequest().getServletContext().getRealPath("");
			if(imatge1 != null){
				FileUtils.copyFile(imatge1, new File(realpath + SERVERIMAGEPATH + ref + IMG1));
				producte.setImatge1(SERVERIMAGEPATH+ref+IMG1);
			}
			if(imatge2 != null){
				FileUtils.copyFile(imatge2, new File(realpath + SERVERIMAGEPATH + ref + IMG2));
				producte.setImatge2(SERVERIMAGEPATH+ref+IMG2);
			}
			if(imatge3 != null){
				FileUtils.copyFile(imatge3, new File(realpath + SERVERIMAGEPATH + ref + IMG3));
				producte.setImatge3(SERVERIMAGEPATH+ref+IMG3);
			}
		} catch (IOException e) {
			logger.error(e.getMessage(), e);
			return ERROR;
		}
		
		CategoriesDAO categoriesDAO = new CategoriesDAO();
		producte.setCategories(categoriesDAO.findById(categoriaId));
		
		producte.setData(new Date());
		try{
			producteDAO.save(producte);
		} catch (RuntimeException re) {
			return ERROR;
		}
		
		String[] colors = this.colorsDisponibles.split(",");
		ProductecolorDAO producteColorDAO = new ProductecolorDAO();
		producteColorDAO.deleteProductProps(producte.getId());
		ColorDAO cDAO = new ColorDAO();
		ProductecolorId producteColorId = null;
		Set<Productecolor> producteColors = new HashSet<Productecolor>();
		
		for(int i=0; i<colors.length; i++){
			Color color = cDAO.findById(Integer.valueOf(colors[i].trim()));
			producteColorId = new ProductecolorId(producte.getId(), color.getId());
			Productecolor pc = new Productecolor(producteColorId, producte, color);
			producteColors.add(pc);
		}
		producte.setProductecolors(producteColors);
		
		String[] promocions = promocionsDisponibles.split(",");
		ProductepromocioDAO productepromocioDAO = new ProductepromocioDAO();
		productepromocioDAO.deleteProductePromocio(producte.getId());
		PromocioDAO promocioDAO = new PromocioDAO();
		ProductepromocioId productePromocioId = null;
		Set<Productepromocio> productesPromocions = new HashSet<Productepromocio>();
		
		for(int i=0; i<promocions.length; i++){
			if(promocions[i].trim().length() > 0){
				Promocio promocio = promocioDAO.findById(Integer.valueOf(promocions[i]));
				productePromocioId = new ProductepromocioId(producte.getId(), promocio.getId());
				Productepromocio pp = new Productepromocio(productePromocioId, producte, promocio);
				productesPromocions.add(pp);
			}
		}
		producte.setProductepromocios(productesPromocions);
		
		if(productePare .trim().length() > 0)
			producte.setProducte(producteDAO.findByRef(productePare).get(0));
		
		try{
			producteDAO.save(producte);
		} catch (RuntimeException re) {
			return ERROR;
		}
		
		return SUCCESS;
	}
	
	
	public List<Producte> getProductes() {
		return productes;
	}

	public void setProductes(List<Producte> productes) {
		this.productes = productes;
	}

	public Producte getProducte() {
		return producte;
	}

	public void setProducte(Producte producte) {
		this.producte = producte;
	}

	public String getRef() {
		return ref;
	}

	public void setRef(String ref) {
		this.ref = ref;
	}

	public int getCategoriaId() {
		return categoriaId;
	}

	public void setCategoriaId(int categoriaId) {
		this.categoriaId = categoriaId;
	}
	
	public List<Color> getColorsList(String[] colors){
		
		List<Color> colorsList = new ArrayList<Color>();
		ColorDAO colorDAO = new ColorDAO();
		
		for (String color : colors) {
			colorsList.add(colorDAO.findById(Integer.valueOf(color)));
		}
		
		return colorsList;
	}
	
	/**
	 * @return the producteId
	 */
	public long getProducteId() {
		return producteId;
	}

	/**
	 * @param producteId the producteId to set
	 */
	public void setProducteId(long producteId) {
		this.producteId = producteId;
	}

	public String getColorsDisponibles() {
		return colorsDisponibles;
	}

	public void setColorsDisponibles(String colorsDisponibles) {
		this.colorsDisponibles = colorsDisponibles;
	}

	public String getTitol() {
		return titol;
	}

	public void setTitol(String titol) {
		this.titol = titol;
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public float getPreu() {
		return preu;
	}

	public void setPreu(float preu) {
		this.preu = preu;
	}

	public int getStock() {
		return stock;
	}

	public void setStock(int stock) {
		this.stock = stock;
	}


	public Date getData() {
		return data;
	}

	public void setData(Date data) {
		this.data = data;
	}

	public List<com.selya.store.global.beans.Color> getColors() {
		return colors;
	}

	public void setColors(List<com.selya.store.global.beans.Color> colors) {
		this.colors = colors;
	}

	/**
	 * @return the categories
	 */
	public List<com.selya.store.global.beans.Categories> getCategories() {
		return categories;
	}

	/**
	 * @param categories the categories to set
	 */
	public void setCategories(List<com.selya.store.global.beans.Categories> categories) {
		this.categories = categories;
	}

	public File getImatge1() {
		return imatge1;
	}

	public void setImatge1(File imatge1) {
		this.imatge1 = imatge1;
	}

	public File getImatge2() {
		return imatge2;
	}

	public void setImatge2(File imatge2) {
		this.imatge2 = imatge2;
	}

	public File getImatge3() {
		return imatge3;
	}

	public void setImatge3(File imatge3) {
		this.imatge3 = imatge3;
	}
	
	public String getLanguage() {
		return language;
	}

	public void setLanguage(String language) {
		this.language = language;
	}

	public String getProductePare() {
		return productePare;
	}

	public void setProductePare(String productePare) {
		this.productePare = productePare;
	}

	/**
	 * @return the selectedColors
	 */
	public List<com.selya.store.global.beans.Color> getSelectedColors() {
		return selectedColors;
	}

	/**
	 * @param selectedColors the selectedColors to set
	 */
	public void setSelectedColors(List<com.selya.store.global.beans.Color> selectedColors) {
		this.selectedColors = selectedColors;
	}

	public int getPes() {
		return pes;
	}

	public void setPes(int pes) {
		this.pes = pes;
	}

	public List<Promocio> getPromocions() {
		return promocions;
	}

	public void setPromocions(List<Promocio> promocions) {
		this.promocions = promocions;
	}

	public List<Promocio> getPromocionsSelected() {
		return promocionsSelected;
	}

	public void setPromocionsSelected(List<Promocio> promocionsSelected) {
		this.promocionsSelected = promocionsSelected;
	}

	public String getPromocionsDisponibles() {
		return promocionsDisponibles;
	}

	public void setPromocionsDisponibles(String promocionsDisponibles) {
		this.promocionsDisponibles = promocionsDisponibles;
	}

}
