package com.selya.store.back.action;

import java.util.List;
import java.util.Set;

import com.selya.store.global.action.BaseAction;
import com.selya.store.persistance.Carreto;
import com.selya.store.persistance.Usuaris;
import com.selya.store.persistance.UsuarisDAO;

/**
 * 
 * @author Daniel Martín
 *
 */
public class UsuarisAction extends BaseAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3140878860248952209L;
	
	private List<Usuaris> usuaris;
	private Usuaris usuari;
	private Set<Carreto> comandes;
	
	private String nom;
	private String cognom1;
	private String cognom2;
	private String username;
	private String email;
	private long usuariId;
	
	
	@Override
	public void prepare() throws Exception {
		super.prepare();
	}
	
	public String search(){
		
		UsuarisDAO usuarisDAO = new UsuarisDAO();
		usuaris = usuarisDAO.findUsuarisByParams(nom, cognom1, cognom2, email, username);
		
		return SUCCESS;
	}
	
	@SuppressWarnings("unchecked")
	public String list(){
		UsuarisDAO usuarisDAO = new UsuarisDAO();
		setUsuaris(usuarisDAO.findAll());
		usuaris = getResultsByPage(usuaris);
		return SUCCESS;
	}
	
	public String edit(){
		UsuarisDAO usuarisDAO = new UsuarisDAO();
		usuari = usuarisDAO.findById(usuariId);
		setComandes(usuari.getCarretos());
		return SUCCESS;
	}
	
	public String baixa(){
		UsuarisDAO uDAO = new UsuarisDAO();
		uDAO.delete(uDAO.findById(usuariId));
		return SUCCESS;
	}

	public List<Usuaris> getUsuaris() {
		return usuaris;
	}

	public void setUsuaris(List<Usuaris> usuaris) {
		this.usuaris = usuaris;
	}

	public Usuaris getUsuari() {
		return usuari;
	}

	public void setUsuari(Usuaris usuari) {
		this.usuari = usuari;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getCognom1() {
		return cognom1;
	}

	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}

	public String getCognom2() {
		return cognom2;
	}

	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	/**
	 * @return the usuariId
	 */
	public long getUsuariId() {
		return usuariId;
	}

	/**
	 * @param usuariId the usuariId to set
	 */
	public void setUsuariId(long usuariId) {
		this.usuariId = usuariId;
	}

	public Set<Carreto> getComandes() {
		return comandes;
	}

	public void setComandes(Set<Carreto> comandes) {
		this.comandes = comandes;
	}

}
