package com.selya.store.front.action;

import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import com.selya.store.global.action.BaseAction;
import com.selya.store.global.utils.Globals;
import com.selya.store.persistance.Carreto;
import com.selya.store.persistance.CarretoDAO;
import com.selya.store.persistance.Carretoproducte;
import com.selya.store.persistance.CarretoproducteDAO;
import com.selya.store.persistance.CarretoproducteId;
import com.selya.store.persistance.Color;
import com.selya.store.persistance.ColorDAO;
import com.selya.store.persistance.EstatcarretoDAO;
import com.selya.store.persistance.Formaenviament;
import com.selya.store.persistance.FormaenviamentDAO;
import com.selya.store.persistance.Formapagament;
import com.selya.store.persistance.FormapagamentDAO;
import com.selya.store.persistance.Producte;
import com.selya.store.persistance.ProducteDAO;
import com.selya.store.persistance.Usuaris;

public class CarretoAction extends BaseAction {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 2484494350232825445L;

	private static String CARRETO = "carreto";
	
	private Carreto carreto;
	private List<Formapagament> formesPagament;
	private List<Formaenviament> formesEnviament;
	private Usuaris usuari;
	private int formaPagament;
	private int formaEnviament;
	private long producteId;
	private String productsToUpdate;
	
	private String mida;
	private int color;
	private int quantitat;
	private String url;
	
	@Override
	public void prepare() throws Exception {
		carreto = (Carreto) getRequest().getSession().getAttribute(CARRETO);
		super.prepare();
	}
	
	public String edit(){
		return SUCCESS;
	}
	
	@SuppressWarnings("unchecked")
	public String validar(){
		carreto = (Carreto) getRequest().getSession().getAttribute(CARRETO);
		EstatcarretoDAO ecDAO = new EstatcarretoDAO();
		carreto.setEstatcarreto(ecDAO.findByDescripcio("Validat").get(0));
		CarretoDAO carretoDAO = new CarretoDAO();
		carretoDAO.merge(carreto);
		FormapagamentDAO fpDAO = new FormapagamentDAO();
		formesPagament = fpDAO.findAll();
		FormaenviamentDAO feDAO = new FormaenviamentDAO();
		formesEnviament = feDAO.findAll();
		getRequest().getSession().setAttribute(CARRETO, carreto);
		return SUCCESS;
	}
	
	public String pagament(){
		carreto = (Carreto) getRequest().getSession().getAttribute(CARRETO);
		FormaenviamentDAO feDAO = new FormaenviamentDAO();
		carreto.setFormaenviament(feDAO.findById(formaEnviament));
		FormapagamentDAO fpDAO = new FormapagamentDAO();
		carreto.setFormapagament(fpDAO.findById(formaPagament));
		EstatcarretoDAO eDAO = new EstatcarretoDAO();
		carreto.setEstatcarreto(eDAO.findByDescripcio("Finalitzat").get(0));
		CarretoDAO cDAO = new CarretoDAO();
		cDAO.save(carreto);
		
		switch (carreto.getFormapagament().getId()) {
		case Globals.CONTRAREEMBOSSAMNET:
			carreto.setEstatcarreto(eDAO.findByDescripcio("Pagat").get(0));
			cDAO.save(carreto);
			return "contrareembossament";
		case Globals.TRANSFERENCIA:
			carreto.setEstatcarreto(eDAO.findByDescripcio("Pagat").get(0));
			cDAO.save(carreto);
			return "transferencia";
		default:
			cDAO.save(carreto);
			return "tpv";	
		}
	}
	
	public String deleteProduct(){
		
		Carretoproducte cp = null;
		boolean finded = false;
		Iterator<Carretoproducte> it = carreto.getCarretoproductes().iterator();
		while(it.hasNext() && !finded){
			cp = it.next();
			if(cp.getProducte().getId() == producteId){
				finded = true;
			}
		}
		
		if(finded){
				Set<Carretoproducte> cps = carreto.getCarretoproductes();
				cps.remove(cp);
				carreto.setCarretoproductes(cps);
				CarretoDAO carretoDAO = new CarretoDAO();
				carretoDAO.merge(carreto);
				getRequest().getSession().setAttribute(CARRETO,carreto);
		}
		return SUCCESS;
	}
	
	public String update(){
		
		String[] products = productsToUpdate.split("#");
		Set<Carretoproducte> cps = new HashSet<Carretoproducte>();
		String ref = "";
		int quantitat;
		for(int i=0; i<products.length;i++){
			if(products[i].trim().length()>0){
				ref = products[i].trim().substring(0, products[i].trim().indexOf("@"));
				quantitat = Integer.parseInt(products[i].trim().substring(products[i].trim().indexOf("@")+1));
				Iterator<Carretoproducte> it = carreto.getCarretoproductes().iterator();
				while(it.hasNext()){
					Carretoproducte cp = it.next();
					if(cp.getProducte().getRef().equals(ref)){
						cp.setQuantitat(quantitat);
						cps.add(cp);
						break;
					}
				}
			}
		}
		
		CarretoDAO carretoDAO = new CarretoDAO();
		carreto.setCarretoproductes(cps);
		carretoDAO.merge(carreto);
		getRequest().getSession().setAttribute(CARRETO,carreto);
		
		return SUCCESS;
	}
	
	public String addProducte(){
		ProducteDAO pDAO = new ProducteDAO();
		Producte producte = pDAO.findById(producteId);
		ColorDAO cDAO = new ColorDAO();
		Color color = cDAO.findById(this.color);
		
		CarretoproducteDAO cpDAO = new CarretoproducteDAO();
		Carretoproducte cp = null;
		
		try{
			cp = cpDAO.findById(new CarretoproducteId(carreto.getId(), producte.getId()));
			if(cp == null){
				cp = new Carretoproducte();
				cp.setId(new CarretoproducteId(carreto.getId(), producte.getId()));
			}
		}catch(RuntimeException e){
			cp = new Carretoproducte();
		}
		cp.setQuantitat(quantitat);
		cp.setCarreto(carreto);
		cp.setColor(color);
		cp.setMida(mida);
		cp.setProducte(producte);
		
		CarretoDAO carretoDAO = new CarretoDAO();
		Usuaris usuari = getUser();
		if(usuari != null){
			if(carretoDAO.findById(carreto.getId()) != null){
				carreto.setUsuaris(usuari);
				carretoDAO.merge(carreto);
				cpDAO.save(cp);
			}else{
				
			}
		}
		
		carreto.getCarretoproductes().add(cp);
		request.getSession().setAttribute(CARRETO, carreto);
		url = "/productes/producte/" + producte.getRef();
		
		return SUCCESS;
	}
	
	public Carreto getCarreto() {
		return carreto;
	}

	public void setCarreto(Carreto carreto) {
		this.carreto = carreto;
	}

	public List<Formapagament> getFormesPagament() {
		return formesPagament;
	}

	public void setFormesPagament(List<Formapagament> formesPagament) {
		this.formesPagament = formesPagament;
	}

	public List<Formaenviament> getFormesEnviament() {
		return formesEnviament;
	}

	public void setFormesEnviament(List<Formaenviament> formesEnviament) {
		this.formesEnviament = formesEnviament;
	}

	public Usuaris getUsuari() {
		return usuari;
	}

	public void setUsuari(Usuaris usuari) {
		this.usuari = usuari;
	}

	public int getFormaPagament() {
		return formaPagament;
	}

	public void setFormaPagament(int formaPagament) {
		this.formaPagament = formaPagament;
	}

	public int getFormaEnviament() {
		return formaEnviament;
	}

	public void setFormaEnviament(int formaEnviament) {
		this.formaEnviament = formaEnviament;
	}

	public long getProducteId() {
		return producteId;
	}

	public void setProducteId(long producteId) {
		this.producteId = producteId;
	}

	public String getProductsToUpdate() {
		return productsToUpdate;
	}

	public void setProductsToUpdate(String productsToUpdate) {
		this.productsToUpdate = productsToUpdate;
	}

	public String getMida() {
		return mida;
	}

	public void setMida(String mida) {
		this.mida = mida;
	}

	public int getColor() {
		return color;
	}

	public void setColor(int color) {
		this.color = color;
	}

	public int getQuantitat() {
		return quantitat;
	}

	public void setQuantitat(int quantitat) {
		this.quantitat = quantitat;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

}
