package com.selya.store.front.action;

import java.io.File;
import java.util.Properties;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import com.selya.store.global.action.BaseAction;
import com.selya.store.global.utils.Globals;
import com.selya.store.persistance.Usuaris;
import com.sun.mail.smtp.SMTPTransport;

public class ContactaAction extends BaseAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3345861536395514473L;
	private File file;
	private String email;
	private String comentari;
	private String titol;
	private Usuaris usuari;
	private String fileName;
	
	
	public String view(){
		usuari = getUser();
		return SUCCESS;
	}
	
	public String save(){

		Properties props = new Properties();
		props.setProperty("mail.smtps.host", "smtp.gmail.com");
        props.setProperty("mail.smtp.socketFactory.class", Globals.SSL_FACTORY);
        props.setProperty("mail.smtp.socketFactory.fallback", "false");
        props.setProperty("mail.smtp.port", "465");
        props.setProperty("mail.smtp.socketFactory.port", "465");
        props.setProperty("mail.smtps.auth", "true");
        props.put("mail.smtps.quitwait", "false");
		
		Session session = Session.getDefaultInstance(props,null);
		session.setDebug(true); //Un cop fincioni la línia es pot comentar, no cal mostrar tot el procès
		MimeMessage message = new MimeMessage(session);
		
		try {
			message.setFrom(new InternetAddress(email));
			message.addRecipient(Message.RecipientType.TO, new InternetAddress(Globals.ADMINMAIL));
			message.setSubject(titol);
			
			if(file != null){
				//Per adjuntar el text i el fitxer és necessari fer un multipart
				MimeMultipart multiPart = new MimeMultipart();
				//Part de text
				MimeBodyPart text = new MimeBodyPart();
				text.setText(comentari, "UTF-8");
				multiPart.addBodyPart(text);
				//Part de l'adjunt
				BodyPart adjunt = new MimeBodyPart();
				adjunt.setDataHandler(new DataHandler(new FileDataSource(file)));
				String fileName = file.getName();
				try{
					fileName = this.fileName.substring(this.fileName.lastIndexOf("/"), this.fileName.length());
				}catch(Exception e1){
					try{
						fileName = this.fileName.substring(this.fileName.lastIndexOf("\\"), this.fileName.length());
					}catch(Exception e2){
						fileName = this.fileName;
					}
				}
				adjunt.setFileName(fileName);
				multiPart.addBodyPart(adjunt);
				message.setContent(multiPart);
			}else{
				message.setText(comentari, "UTF-8");
			}
			
			SMTPTransport t = (SMTPTransport)session.getTransport("smtps");

	        t.connect("smtp.gmail.com", Globals.ADMINMAIL, Globals.PASSWORD);
	        t.sendMessage(message, message.getAllRecipients());      
	        t.close();
			
		} catch (MessagingException e) {
			logger.error(e.getMessage(), e);
			return ERROR;
		}

		return SUCCESS;
	}

	public File getFile() {
		return file;
	}

	public void setFile(File file) {
		this.file = file;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getComentari() {
		return comentari;
	}

	public void setComentari(String comentari) {
		this.comentari = comentari;
	}

	public String getTitol() {
		return titol;
	}

	public void setTitol(String titol) {
		this.titol = titol;
	}

	public Usuaris getUsuari() {
		return usuari;
	}

	public void setUsuari(Usuaris usuari) {
		this.usuari = usuari;
	}

	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}
}
