package com.selya.store.front.action;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Properties;
import java.util.Set;

import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

import org.apache.commons.io.FileUtils;

import com.selya.store.global.action.BaseAction;
import com.selya.store.global.utils.Globals;
import com.selya.store.persistance.CategoriesDAO;
import com.selya.store.persistance.Color;
import com.selya.store.persistance.Comentaris;
import com.selya.store.persistance.Producte;
import com.selya.store.persistance.ProducteDAO;
import com.selya.store.persistance.Productecolor;
import com.selya.store.persistance.Usuaris;
import com.selya.store.persistance.Valoracio;
import com.selya.store.persistance.ValoracioDAO;
import com.sun.mail.smtp.SMTPTransport;

/**
 * 
 * @author Daniel Martín
 *
 */
public class ProducteAction extends BaseAction {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 65217470548023654L;
	private static final String IMG1 = "/imatge1.jpg";
	
	private Producte producte;
	private List<Producte> productes;
	private int categoriaId;
	private String ref;
	private long producteId;
	private List<Color> colors;
	private Set<Comentaris> comentaris;
	private Usuaris usuari;
	private String descripcio;
	private File imatge1;
	private int puntuacio;
	private String url;
	private String fileName;
	
	@SuppressWarnings("unchecked")
	public String list(){
		
		ProducteDAO producteDAO = new ProducteDAO();
		productes = producteDAO.findAll();
		productes = getResultsByPage(productes, "categoriaId", String.valueOf(categoriaId));
		
		return SUCCESS;
	}
	
	public String detail(){
		
		ProducteDAO producteDAO = new ProducteDAO();
		List<com.selya.store.persistance.Producte> producte = producteDAO.findByRef(ref);
		if(producte.size() > 0){
			usuari = getUser();
			this.producte = producte.get(0);
			Iterator<Productecolor> it = this.producte.getProductecolors().iterator();
			colors = new ArrayList<Color>();
			while(it.hasNext())
				colors.add(it.next().getColor());
			comentaris = this.producte.getComentaris();
			return SUCCESS;
		}
		return ERROR;
	}
	
	@SuppressWarnings("unchecked")
	public String producteByCategoria(){
		
		ProducteDAO producteDAO = new ProducteDAO();
		CategoriesDAO categoriesDAO = new CategoriesDAO();
		productes = producteDAO.findByProperty("categories", categoriesDAO.findById(categoriaId));
		productes = getResultsByPage(productes);
		
		return SUCCESS;
	}
	
	public String novetats(){
		
		ProducteDAO producteDAO = new ProducteDAO();
		productes = producteDAO.novetats();
		return SUCCESS;
	}
	
	public String personalitzacions(){
		
		ProducteDAO producteDAO = new ProducteDAO();
		producte = producteDAO.findByRef(ref).get(0);
		usuari = getUser();
		
		return SUCCESS;
	}
	
	public String newPersonalitzacio(){
		
		ProducteDAO producteDAO = new ProducteDAO();
		producte = producteDAO.findByRef(ref).get(0);
		
		return SUCCESS;
	}
	
	public String savePersonalitzacio(){
		
		Properties props = new Properties();
		props.setProperty("mail.smtps.host", "smtp.gmail.com");
        props.setProperty("mail.smtp.socketFactory.class", Globals.SSL_FACTORY);
        props.setProperty("mail.smtp.socketFactory.fallback", "false");
        props.setProperty("mail.smtp.port", "465");
        props.setProperty("mail.smtp.socketFactory.port", "465");
        props.setProperty("mail.smtps.auth", "true");
        props.put("mail.smtps.quitwait", "false");
		
		Session session = Session.getDefaultInstance(props,null);
		session.setDebug(true); //Un cop fincioni la línia es pot comentar, no cal mostrar tot el procès
		MimeMessage message = new MimeMessage(session);
		
		try {
			message.setFrom(new InternetAddress(Globals.ADMINMAIL));
			message.addRecipient(Message.RecipientType.TO, new InternetAddress(Globals.ADMINMAIL));
			message.setSubject("Nova personalització pel producte" + ref);
			
			if(imatge1 != null){
				//Per adjuntar el text i el fitxer és necessari fer un multipart
				MimeMultipart multiPart = new MimeMultipart();
				//Part de text
				MimeBodyPart text = new MimeBodyPart();
				text.setText("<p>Modificació per al producte " + ref + "</p> De l'usuari: " + getUser().getEmail()
							+ "<br/>" + descripcio, "UTF-8");
				multiPart.addBodyPart(text);
				//Part de l'adjunt
				String realpath = getRequest().getServletContext().getRealPath("");
				try {
					FileUtils.copyFile(imatge1, new File(realpath + "temp" + ref + IMG1));
				} catch (IOException e) {
					logger.error(e.getMessage(), e);
					return ERROR;
				}
				BodyPart adjunt = new MimeBodyPart();
				adjunt.setDataHandler(new DataHandler(new FileDataSource(imatge1)));
				String fileName = imatge1.getName();
				try{
					fileName = this.fileName.substring(this.fileName.lastIndexOf("/"), this.fileName.length());
				}catch(Exception e1){
					try{
						fileName = this.fileName.substring(this.fileName.lastIndexOf("\\"), this.fileName.length());
					}catch(Exception e2){
						fileName = this.fileName;
					}
				}
				adjunt.setFileName(fileName);
				multiPart.addBodyPart(adjunt);
				message.setContent(multiPart);
			}else{
				message.setText("<p>Modificació per al producte " + ref + "</p> De l'usuari: " + getUser().getEmail()
						+ "<br/>" + descripcio, "UTF-8");
			}
			
			SMTPTransport t = (SMTPTransport)session.getTransport("smtps");

	        t.connect("smtp.gmail.com", Globals.ADMINMAIL, Globals.PASSWORD);
	        t.sendMessage(message, message.getAllRecipients());      
	        t.close();
			
		} catch (MessagingException e) {
			logger.error(e.getMessage(), e);
			return ERROR;
		}

		return SUCCESS;
		
	}
	
	public String valorar(){
		ProducteDAO producteDAO = new ProducteDAO();
		Producte producte = producteDAO.findById(producteId);
		Valoracio valoracio = new Valoracio(producte, puntuacio, new Date());
		ValoracioDAO valoracioDAO = new ValoracioDAO();
		valoracioDAO.save(valoracio);
		url = "/productes/producte/"+producte.getRef();
		return SUCCESS;
	}
	
	public Producte getProducte() {
		return producte;
	}

	public void setProducte(Producte producte) {
		this.producte = producte;
	}

	public List<Producte> getProductes() {
		return productes;
	}

	public void setProductes(List<Producte> productes) {
		this.productes = productes;
	}

	public int getCategoriaId() {
		return categoriaId;
	}

	public void setCategoriaId(int categoriaId) {
		this.categoriaId = categoriaId;
	}

	public String getRef() {
		return ref;
	}

	public void setRef(String ref) {
		this.ref = ref;
	}

	public long getProducteId() {
		return producteId;
	}

	public void setProducteId(long producteId) {
		this.producteId = producteId;
	}

	public List<Color> getColors() {
		return colors;
	}

	public void setColors(List<Color> colors) {
		this.colors = colors;
	}

	public Set<Comentaris> getComentaris() {
		return comentaris;
	}

	public void setComentaris(Set<Comentaris> comentaris) {
		this.comentaris = comentaris;
	}

	public Usuaris getUsuari() {
		return usuari;
	}

	public void setUsuari(Usuaris usuari) {
		this.usuari = usuari;
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public File getImatge1() {
		return imatge1;
	}

	public void setImatge1(File imatge1) {
		this.imatge1 = imatge1;
	}

	public int getPuntuacio() {
		return puntuacio;
	}

	public void setPuntuacio(int puntuacio) {
		this.puntuacio = puntuacio;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public String getFileName() {
		return fileName;
	}

	public void setFileName(String fileName) {
		this.fileName = fileName;
	}

}
