package com.selya.store.front.action;

import java.util.ArrayList;
import java.util.List;

import com.selya.store.global.action.BaseAction;
import com.selya.store.persistance.Categories;
import com.selya.store.persistance.CategoriesDAO;
import com.selya.store.persistance.Producte;
import com.selya.store.persistance.ProducteDAO;

public class SearchAction extends BaseAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = 2813901590759974823L;
	private String searchText;
	private List<Producte> productes;
	private List<Categories> categories;
	
	@Override
	public String execute() throws Exception {
		
		productes = new ArrayList<Producte>();
		ProducteDAO producteDAO = new ProducteDAO();
		productes.addAll(producteDAO.findLikeByTitelAndRef(searchText));
		
		productes = getResultsByPage(productes, "searchText", searchText);
		
		CategoriesDAO categoriesDAO = new CategoriesDAO();
		categories = categoriesDAO.findAll();
		
		return SUCCESS;
	}

	public String getSearchText() {
		return searchText;
	}

	public void setSearchText(String searchText) {
		this.searchText = searchText;
	}

	public List<Producte> getProductes() {
		return productes;
	}

	public void setProductes(List<Producte> productes) {
		this.productes = productes;
	}

	public List<Categories> getCategories() {
		return categories;
	}

	public void setCategories(List<Categories> categories) {
		this.categories = categories;
	}
}
