package com.selya.store.front.action;

import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.servlet.ServletOutputStream;

import com.selya.store.global.action.BaseAction;
import com.selya.store.global.utils.StringUtils;
import com.selya.store.persistance.Carreto;
import com.selya.store.persistance.CarretoDAO;
import com.selya.store.persistance.Carretoproducte;
import com.selya.store.persistance.CarretoproducteDAO;
import com.selya.store.persistance.EstatcarretoDAO;
import com.selya.store.persistance.Paisos;
import com.selya.store.persistance.PaisosDAO;
import com.selya.store.persistance.Usuaris;
import com.selya.store.persistance.UsuarisDAO;

public class UsuariAction extends BaseAction {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -6407057182063539295L;
	
	private ServletOutputStream sos;
	private String url;
	
	private String id;
	private String nom;
	private String cognom1;
	private String cognom2;
	private String adreca;
	private String cp;
	private String telefon;
	private String poblacio;
	private String provincia;
	private int pais;
	private String email;
	private String username;
	private String password;
	private Usuaris usuari;
	private String dni;
	private List<Paisos> paisos;
	
	public String logon(){
		if(super.getUser() != null){
			usuari = super.getUser();
			return ERROR;
		}
		return SUCCESS;
	}
	
	public String login(){
		
		UsuarisDAO usuariDAO = new UsuarisDAO();
		usuari = usuariDAO.loginUser(username, password);
		url = getUrl().substring(getUrl().indexOf("/Selya/")+6);
		if(usuari != null){
			request.getSession().setAttribute(SESSION_USER, usuari);
			
			CarretoDAO carretoDAO = new CarretoDAO();
			Carreto carreto = carretoDAO.getLastCarreto(usuari);
			Carreto carretoSession = (Carreto) request.getSession().getAttribute(SESSION_CARRETO);
			if(carreto != null){
				if(carreto.getCarretoproductes().size() > 0)
					request.getSession().setAttribute(SESSION_CARRETO, carreto);
				else{
					if(carretoSession.getCarretoproductes().size() > 0){
						CarretoproducteDAO carretoproducteDAO = new CarretoproducteDAO();
						carretoSession.setUsuaris(usuari);
						carretoSession.setDataCreacio(new Date());
						carretoSession.setDataModificacio(new Date());
	    				EstatcarretoDAO estatcarretoDAO = new EstatcarretoDAO();
	    				carretoSession.setEstatcarreto(estatcarretoDAO.findById(1));
	    				Set<Carretoproducte> productes = carretoSession.getCarretoproductes();
	    				carretoSession.setCarretoproductes(new HashSet<Carretoproducte>());
	    				carretoDAO.save(carretoSession);
	    				Iterator<Carretoproducte> it = productes.iterator();
	    				while(it.hasNext()){
	    					Carretoproducte carretoproducte = it.next();
	    					carretoproducte.getId().setCarretoId(carretoSession.getId());
	    					carretoproducteDAO.save(carretoproducte);
	    				}
	    				carreto = carretoSession;
	    				carreto.setCarretoproductes(productes);
	    				request.getSession().setAttribute(SESSION_CARRETO, carreto);
					}else
						request.getSession().setAttribute(SESSION_CARRETO, carreto);
				}
			}else{
				if(carretoSession != null){
					carretoSession.setUsuaris(usuari);
					carretoSession.setDataCreacio(new Date());
					carretoSession.setDataModificacio(new Date());
    				EstatcarretoDAO estatcarretoDAO = new EstatcarretoDAO();
    				carretoSession.setEstatcarreto(estatcarretoDAO.findById(1));
    				Set<Carretoproducte> productes = carretoSession.getCarretoproductes();
    				carretoSession.setCarretoproductes(new HashSet<Carretoproducte>());
    				carretoDAO.save(carretoSession);
    				CarretoproducteDAO carretoproducteDAO = new CarretoproducteDAO();
    				Iterator<Carretoproducte> it = productes.iterator();
    				while(it.hasNext()){
    					Carretoproducte carretoproducte = it.next();
    					carretoproducte.getId().setCarretoId(carretoSession.getId());
    					carretoproducteDAO.save(carretoproducte);
    				}
    				carreto = carretoSession;
    				carreto.setCarretoproductes(productes);
    				request.getSession().setAttribute(SESSION_CARRETO, carreto);
				}else{
					carreto = new Carreto();
    				carreto.setDataCreacio(new Date());
    				carreto.setDataModificacio(new Date());
    				carretoDAO.save(carreto);
    				carreto.setUsuaris(usuari);
    				carretoDAO.save(carreto);
    				request.getSession().setAttribute(SESSION_CARRETO, new Carreto());
				}
			}
			return SUCCESS;
		}
		addActionMessage(getText("front.menu.lateral.error.login"));
		return ERROR;
	}
	
	@SuppressWarnings("unchecked")
	public String edit(){
		usuari = super.getUser();
		if(usuari != null){
			PaisosDAO paisosDAO = new PaisosDAO();
			paisos = paisosDAO.findAll();
			return SUCCESS;
		}
		return ERROR;
	}
	
	@SuppressWarnings("unchecked")
	public String newUser(){
		usuari = super.getUser();
		if(usuari != null)
			return ERROR;
		PaisosDAO paisosDAO = new PaisosDAO();
		paisos = paisosDAO.findAll();
		return SUCCESS;
	}
	
	public String save(){
		Usuaris usuari = new Usuaris();
		UsuarisDAO usuariDAO =  new UsuarisDAO();
		if(id != null && id.trim().length() > 0){
			usuari = usuariDAO.findById(new Long(id));
		}
		
		usuari.setNom(nom);
		usuari.setCognom1(cognom1);
		usuari.setCognom2(cognom2);
		usuari.setCarrer(adreca);
		usuari.setCp(cp);
		usuari.setDni(dni);
		usuari.setTelefon(telefon);
		usuari.setPoblacio(poblacio);
		usuari.setProvincia(provincia);
		PaisosDAO paisosDAO = new PaisosDAO();
		usuari.setPaisos(paisosDAO.findById(pais));
		usuari.setEmail(email);
		usuari.setPsw(StringUtils.hash(password));
		usuari.setUsuari(username);
		
		usuariDAO.save(usuari);
		getRequest().getSession().setAttribute("user", usuari);
		
		return SUCCESS;
	}
	
	public String logoff(){
		getRequest().getSession().setAttribute(SESSION_USER, null);
		getRequest().getSession().setAttribute(SESSION_CARRETO, null);
		return SUCCESS;
	}
	
	public String preferits(){
		usuari = getUser();
		return SUCCESS;
	}
	
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public String getCognom1() {
		return cognom1;
	}

	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}

	public String getCognom2() {
		return cognom2;
	}

	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}

	public String getAdreca() {
		return adreca;
	}

	public void setAdreca(String adreca) {
		this.adreca = adreca;
	}

	public String getCp() {
		return cp;
	}

	public void setCp(String cp) {
		this.cp = cp;
	}

	public String getTelefon() {
		return telefon;
	}

	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}

	public String getPoblacio() {
		return poblacio;
	}

	public void setPoblacio(String poblacio) {
		this.poblacio = poblacio;
	}

	public String getProvincia() {
		return provincia;
	}

	public void setProvincia(String provincia) {
		this.provincia = provincia;
	}

	public int getPais() {
		return pais;
	}

	public void setPais(int pais) {
		this.pais = pais;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		this.username = username;
	}

	public String getPassword() {
		return password;
	}

	public void setPassword(String password) {
		this.password = password;
	}

	public Usuaris getUsuari() {
		return usuari;
	}

	public void setUsuari(Usuaris usuari) {
		this.usuari = usuari;
	}

	public List<Paisos> getPaisos() {
		return paisos;
	}

	public void setPaisos(List<Paisos> paisos) {
		this.paisos = paisos;
	}

	public ServletOutputStream getSos() {
		return sos;
	}

	public void setSos(ServletOutputStream sos) {
		this.sos = sos;
	}

	public String getDni() {
		return dni;
	}

	public void setDni(String dni) {
		this.dni = dni;
	}

	public String getUrl() {
		return url;
	}

	public void setUrl(String url) {
		this.url = url;
	}

}
