package com.selya.store.global.beans;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

import com.selya.store.persistance.Categories;
import com.selya.store.persistance.Color;
import com.selya.store.persistance.ColorDAO;

public class Producte {
	
	private long producteId;
	private String ref;
	private String titol;
	private String descripcio;
	private float preu;
	private int stock;
	private File image1;
	private File image2;
	private File image3;
	private Date data;
	private Categories categoria;
	private List<Color> colors;
	
	public Producte(){
		colors = new ArrayList<Color>();
	}
	
	public Producte (long producteId, String ref, String titol, String descripcio, float preu, int stock,
			File image1, File image2, File image3, Categories categoria, List<Color> colors, Date data){
		this.producteId = producteId;
		this.ref = ref;
		this.titol = titol;
		this.descripcio = descripcio;
		this.preu = preu;
		this.stock = stock;
		this.image1 = image1;
		this.image2 = image2;
		this.image3 = image3;
		this.categoria = categoria;
		this.colors = colors;
		this.data = data;
	}
	
	public Producte(com.selya.store.persistance.Producte producte){
		this.producteId = producte.getId();
		this.ref = producte.getRef();
		this.titol = producte.getTitol();
		this.descripcio = producte.getDescripcio();
		this.preu = producte.getPreu();
		this.stock = producte.getStock();
		this.image1 = new File(producte.getImatge1());
		this.image2 = new File(producte.getImatge2());
		this.image3 = new File(producte.getImatge3());
		this.categoria = producte.getCategories();
		this.colors = producte.processListColors();
		this.data = producte.getData();
	}
	
	public static List<Producte> toProducteList(List<com.selya.store.persistance.Producte> productes){
		List<Producte> products = new ArrayList<Producte>();
		
		Iterator<com.selya.store.persistance.Producte> it = productes.iterator();
		while(it.hasNext()){
			products.add(new Producte(it.next()));
		}
		
		return products;
	}
	
	public void addColor(int color){
		ColorDAO colDAO = new ColorDAO();
		this.colors.add(colDAO.findById(color));
	}
	
	public long getProducteId() {
		return producteId;
	}

	public void setProducteId(long producteId) {
		this.producteId = producteId;
	}

	public String getRef() {
		return ref;
	}

	public void setRef(String ref) {
		this.ref = ref;
	}

	public String getTitol() {
		return titol;
	}

	public void setTitol(String titol) {
		this.titol = titol;
	}

	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	public float getPreu() {
		return preu;
	}

	public void setPreu(float preu) {
		this.preu = preu;
	}

	public int getStock() {
		return stock;
	}

	public void setStock(int stock) {
		this.stock = stock;
	}

	public File getImage1() {
		return image1;
	}

	public void setImage1(File image1) {
		this.image1 = image1;
	}

	public File getImage2() {
		return image2;
	}

	public void setImage2(File image2) {
		this.image2 = image2;
	}

	public File getImage3() {
		return image3;
	}

	public void setImage3(File image3) {
		this.image3 = image3;
	}

	public List<Color> getColors() {
		return colors;
	}

	public void setColors(List<Color> colors) {
		this.colors = colors;
	}

	public Categories getCategoria() {
		return categoria;
	}

	public void setCategoria(Categories categoria) {
		this.categoria = categoria;
	}

	public Date getData() {
		return data;
	}

	public void setData(Date data) {
		this.data = data;
	}

}
