package com.selya.store.persistance;

import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

/**
 * Carreto entity. @author MyEclipse Persistence Tools
 */
@Entity
@Table(name = "carreto", catalog = "tfc")
public class Carreto implements java.io.Serializable {

	// Fields

	/**
	 * 
	 */
	private static final long serialVersionUID = 4248071927852209507L;
	private long id;
	private Formaenviament formaenviament;
	private Estatcarreto estatcarreto;
	private Formapagament formapagament;
	private Date dataCreacio;
	private Date dataModificacio;
	private Usuaris usuaris;
	private Set<Carretoproducte> carretoproductes = new HashSet<Carretoproducte>(
			0);

	// Constructors

	/** default constructor */
	public Carreto() {
	}

	/** minimal constructor */
	public Carreto(Estatcarreto estatcarreto, Formapagament formapagament,
			Date dataCreacio, Date dataModificacio) {
		this.estatcarreto = estatcarreto;
		this.formapagament = formapagament;
		this.dataCreacio = dataCreacio;
		this.dataModificacio = dataModificacio;
	}

	/** full constructor */
	public Carreto(Formaenviament formaenviament, Estatcarreto estatcarreto,
			Formapagament formapagament, Date dataCreacio,
			Date dataModificacio, Usuaris usuaris,
			Set<Carretoproducte> carretoproductes) {
		this.formaenviament = formaenviament;
		this.estatcarreto = estatcarreto;
		this.formapagament = formapagament;
		this.dataCreacio = dataCreacio;
		this.dataModificacio = dataModificacio;
		this.usuaris = usuaris;
		this.carretoproductes = carretoproductes;
	}

	// Property accessors
	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "Id", unique = true, nullable = false)
	public long getId() {
		return this.id;
	}

	public void setId(long id) {
		this.id = id;
	}

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "FormaEnviament")
	public Formaenviament getFormaenviament() {
		return this.formaenviament;
	}

	public void setFormaenviament(Formaenviament formaenviament) {
		this.formaenviament = formaenviament;
	}

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "EstatId", nullable = false)
	public Estatcarreto getEstatcarreto() {
		return this.estatcarreto;
	}

	public void setEstatcarreto(Estatcarreto estatcarreto) {
		this.estatcarreto = estatcarreto;
	}

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "FormaPagamentId")
	public Formapagament getFormapagament() {
		return this.formapagament;
	}

	public void setFormapagament(Formapagament formapagament) {
		this.formapagament = formapagament;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "DataCreacio", nullable = false, length = 10)
	public Date getDataCreacio() {
		return this.dataCreacio;
	}

	public void setDataCreacio(Date dataCreacio) {
		this.dataCreacio = dataCreacio;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "DataModificacio", nullable = false, length = 10)
	public Date getDataModificacio() {
		return this.dataModificacio;
	}

	public void setDataModificacio(Date dataModificacio) {
		this.dataModificacio = dataModificacio;
	}

	@OneToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "UsuariId", nullable = false)
	public Usuaris getUsuaris() {
		return this.usuaris;
	}

	public void setUsuaris(Usuaris usuaris) {
		this.usuaris = usuaris;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "carreto")
	public Set<Carretoproducte> getCarretoproductes() {
		return this.carretoproductes;
	}

	public void setCarretoproductes(Set<Carretoproducte> carretoproductes) {
		this.carretoproductes = carretoproductes;
	}
	
	public float getPreuCarreto(Date data){
		float preu = 0;
		Iterator<Carretoproducte> it = carretoproductes.iterator();
		while(it.hasNext()){
			Carretoproducte cp = it.next();
			preu += cp.getProducte().preuPromocionat(data) * cp.getQuantitat();
		}
		
		return preu;
	}
	
	@Transient
	public float getPreuCarreto(){
		float preu = 0;
		Iterator<Carretoproducte> it = carretoproductes.iterator();
		while(it.hasNext()){
			Carretoproducte cp = it.next();
			preu += cp.getProducte().preuPromocionat(new Date()) * cp.getQuantitat();
		}
		
		return preu;
	}

}