package com.selya.store.persistance;

import java.util.List;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.Transaction;

import static org.hibernate.criterion.Example.create;
import org.apache.log4j.Logger;


/**
 * A data access object (DAO) providing persistence and search support for
 * Carretoproducte entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see com.selya.store.persistance.Carretoproducte
 * @author MyEclipse Persistence Tools
 */

public class CarretoproducteDAO extends BaseHibernateDAO {
	private static final Logger log = Logger
			.getLogger(CarretoproducteDAO.class);
	// property constants
	public static final String QUANTITAT = "quantitat";

	public void save(Carretoproducte transientInstance) {
		log.debug("saving Carretoproducte instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().saveOrUpdate(transientInstance);
			tx.commit();
			getSession().close();
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(Carretoproducte persistentInstance) {
		log.debug("deleting Carretoproducte instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().delete(persistentInstance);
			tx.commit();
			getSession().close();
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public Carretoproducte findById(
			com.selya.store.persistance.CarretoproducteId id) {
		log.debug("getting Carretoproducte instance with id: " + id);
		try {
			getSession().clear();
			Carretoproducte instance = (Carretoproducte) getSession().get(
					"com.selya.store.persistance.Carretoproducte", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List<Carretoproducte> findByExample(Carretoproducte instance) {
		log.debug("finding Carretoproducte instance by example");
		try {
			getSession().clear();
			List<Carretoproducte> results = (List<Carretoproducte>) getSession()
					.createCriteria(
							"com.selya.store.persistance.Carretoproducte")
					.add(create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding Carretoproducte instance with property: "
				+ propertyName + ", value: " + value);
		try {
			getSession().clear();
			String queryString = "from Carretoproducte as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List<Carretoproducte> findByQuantitat(Object quantitat) {
		return findByProperty(QUANTITAT, quantitat);
	}

	public List findAll() {
		log.debug("finding all Carretoproducte instances");
		try {
			getSession().clear();
			String queryString = "from Carretoproducte";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public Carretoproducte merge(Carretoproducte detachedInstance) {
		log.debug("merging Carretoproducte instance");
		try {
			Carretoproducte result = (Carretoproducte) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(Carretoproducte instance) {
		log.debug("attaching dirty Carretoproducte instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(Carretoproducte instance) {
		log.debug("attaching clean Carretoproducte instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}