package com.selya.store.persistance;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.log4j.Logger;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import com.selya.store.global.utils.Globals;

/**
 * Color entity. @author MyEclipse Persistence Tools
 */
@Entity
@Table(name = "color", catalog = "tfc")
public class Color implements java.io.Serializable {

	protected Logger logger = Logger.getLogger(this.getClass().getName());

	// Fields

	private int id;
	private String descripcio;
	private Set<Productecolor> productecolors = new HashSet<Productecolor>(0);
	private Set<Carretoproducte> carretoproductes = new HashSet<Carretoproducte>(
			0);

	// Constructors

	/** default constructor */
	public Color() {
	}

	/** minimal constructor */
	public Color(String descripcio) {
		this.descripcio = descripcio;
	}
	
	/** full constructor */
	public Color(String descripcio, Set<Productecolor> productecolors,
			Set<Carretoproducte> carretoproductes) {
		this.descripcio = descripcio;
		this.productecolors = productecolors;
		this.carretoproductes = carretoproductes;
	}

	// Property accessors
	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "Id", unique = true, nullable = false)
	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}

	@Column(name = "Descripcio", nullable = false, length = 65535)
	public String getDescripcio() {
		return this.descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY, mappedBy = "color")
	public Set<Productecolor> getProductecolors() {
		return this.productecolors;
	}

	public void setProductecolors(Set<Productecolor> productecolors) {
		this.productecolors = productecolors;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY, mappedBy = "color")
	public Set<Carretoproducte> getCarretoproductes() {
		return this.carretoproductes;
	}

	public void setCarretoproductes(Set<Carretoproducte> carretoproductes) {
		this.carretoproductes = carretoproductes;
	}
	
	/**
	 * Métode que retorna la descripció en l'idioma passat epr paràmetre
	 * @param language
	 * @return
	 */
	public String getTitol(String language){
		
		if (this.descripcio != null && !this.descripcio.equals("")) {
			String nombre=null;
			try {
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				DocumentBuilder db = dbf.newDocumentBuilder();
			    InputSource is = new InputSource();
			    is.setCharacterStream(new StringReader(descripcio));
			    Document doc = db.parse(is);
				NodeList nodeLst = doc.getElementsByTagName("data");
				for (int s = 0; s < nodeLst.getLength(); s++) {

				    Node fstNode = nodeLst.item(s);
				    
				    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
				  
				      Element fstElmnt = (Element) fstNode;
				      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("language");
				      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
				      NodeList fstNm = fstNmElmnt.getChildNodes();
				      if (fstNm.item(0).getNodeValue().equals(language)) {
				    	  NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("content"); 
				    	  Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
					      NodeList lstNm = lstNmElmnt.getChildNodes();
					      nombre = ((Node) lstNm.item(0)).getNodeValue();
				      }
				    }

				  }
			} catch (SAXException e) {
				logger.error(e.getMessage(),e);
			} catch (IOException e) {
				logger.error(e.getMessage(),e);
			} catch (ParserConfigurationException e) {
				logger.error(e.getMessage(),e);
			} catch (Exception e) {
				logger.error(e.getMessage(),e);
			}
			return nombre;
			
		}
		else {
			return "";
		}
	}
	
	/**
	 * Mètode que assigna la descripció per amb l'idioma passat per paràmetre al color
	 * @param language
	 * @param descripcio
	 */
	public void setDescripcio(String language, String descripcio){
		
		if (this.descripcio != null && !this.descripcio.equals("")) {
			try {
				boolean idiomaFinded = false;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				DocumentBuilder db = dbf.newDocumentBuilder();
			    InputSource is = new InputSource();
			    is.setCharacterStream(new StringReader(this.descripcio));
			    Document doc = db.parse(is);
				NodeList nodeLst = doc.getElementsByTagName("data");
				for (int s = 0; s < nodeLst.getLength(); s++) {

				    Node fstNode = nodeLst.item(s);
				    
				    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
				  
				      Element fstElmnt = (Element) fstNode;
				      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("language");
				      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
				      NodeList fstNm = fstNmElmnt.getChildNodes();
				      if (fstNm.item(0).getNodeValue().equals(language)) {
				    	  idiomaFinded = true;
				    	  NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("content"); 
				    	  Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
					      NodeList lstNm = lstNmElmnt.getChildNodes();
					      ((Node) lstNm.item(0)).setNodeValue(descripcio);
				      }
				    }

				  }
				if(!idiomaFinded){
					 StringBuffer sb = new StringBuffer(this.descripcio);
					 int ix = sb.indexOf("</data>");
					 sb.insert(ix+7, Globals.setDataTag(descripcio, language));
					 this.descripcio = sb.toString();
			      }else{
			    	  Source source = new DOMSource(doc);
			    	  StringWriter stringWriter = new StringWriter();
			    	  Result result = new StreamResult(stringWriter);
			    	  TransformerFactory factory = TransformerFactory.newInstance();
			    	  Transformer transformer = factory.newTransformer();
			    	  transformer.transform(source, result);
			    	  this.descripcio = stringWriter.getBuffer().toString();
			      }
			} catch (SAXException e) {
				logger.error(e.getMessage(),e);
			} catch (IOException e) {
				logger.error(e.getMessage(),e);
			} catch (ParserConfigurationException e) {
				logger.error(e.getMessage(),e);
			} catch (Exception e) {
				logger.error(e.getMessage(),e);
			}
		}
		else {
			StringBuffer sb = new StringBuffer(10);
			sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			sb.append("<root>");
			sb.append(Globals.setDataTag(descripcio, language));
			sb.append("</root>");
			this.descripcio = sb.toString();
		}
	}

	/**
	 * Métode que retorna la descripció en l'idioma passat epr paràmetre
	 * @param language
	 * @return
	 */
	public String getDescripcio(String language){
		
		if (this.descripcio != null && !this.descripcio.equals("")) {
			String nombre=null;
			try {
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				DocumentBuilder db = dbf.newDocumentBuilder();
			    InputSource is = new InputSource();
			    is.setCharacterStream(new StringReader(descripcio));
			    Document doc = db.parse(is);
				NodeList nodeLst = doc.getElementsByTagName("data");
				for (int s = 0; s < nodeLst.getLength(); s++) {

				    Node fstNode = nodeLst.item(s);
				    
				    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
				  
				      Element fstElmnt = (Element) fstNode;
				      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("language");
				      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
				      NodeList fstNm = fstNmElmnt.getChildNodes();
				      if (fstNm.item(0).getNodeValue().equals(language)) {
				    	  NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("content"); 
				    	  Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
					      NodeList lstNm = lstNmElmnt.getChildNodes();
					      nombre = ((Node) lstNm.item(0)).getNodeValue();
				      }
				    }

				  }
			} catch (SAXException e) {
				logger.error(e.getMessage(),e);
			} catch (IOException e) {
				logger.error(e.getMessage(),e);
			} catch (ParserConfigurationException e) {
				logger.error(e.getMessage(),e);
			} catch (Exception e) {
				logger.error(e.getMessage(),e);
			}
			return nombre;
			
		}
		else {
			return "";
		}
	}
}