package com.selya.store.persistance;

import java.util.List;
import java.util.Set;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.Transaction;

import static org.hibernate.criterion.Example.create;
import org.apache.log4j.Logger;


/**
 * A data access object (DAO) providing persistence and search support for
 * Formaenviament entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see com.selya.store.persistance.Formaenviament
 * @author MyEclipse Persistence Tools
 */

public class FormaenviamentDAO extends BaseHibernateDAO {
	private static final Logger log = Logger
			.getLogger(FormaenviamentDAO.class);
	// property constants
	public static final String DESCRIPCIO = "descripcio";

	public void save(Formaenviament transientInstance) {
		log.debug("saving Formaenviament instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().saveOrUpdate(transientInstance);
			tx.commit();
			getSession().close();
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(Formaenviament persistentInstance) {
		log.debug("deleting Formaenviament instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().delete(persistentInstance);
			tx.commit();
			getSession().close();
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public Formaenviament findById(java.lang.Integer id) {
		log.debug("getting Formaenviament instance with id: " + id);
		try {
			Formaenviament instance = (Formaenviament) getSession().get(
					"com.selya.store.persistance.Formaenviament", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List<Formaenviament> findByExample(Formaenviament instance) {
		log.debug("finding Formaenviament instance by example");
		try {
			List<Formaenviament> results = (List<Formaenviament>) getSession()
					.createCriteria(
							"com.selya.store.persistance.Formaenviament")
					.add(create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding Formaenviament instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from Formaenviament as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List<Formaenviament> findByDescripcio(Object descripcio) {
		return findByProperty(DESCRIPCIO, descripcio);
	}

	public List findAll() {
		log.debug("finding all Formaenviament instances");
		try {
			String queryString = "from Formaenviament";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public Formaenviament merge(Formaenviament detachedInstance) {
		log.debug("merging Formaenviament instance");
		try {
			Formaenviament result = (Formaenviament) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(Formaenviament instance) {
		log.debug("attaching dirty Formaenviament instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(Formaenviament instance) {
		log.debug("attaching clean Formaenviament instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}