package com.selya.store.persistance;

import java.util.List;
import java.util.Set;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.Transaction;

import static org.hibernate.criterion.Example.create;
import org.apache.log4j.Logger;


/**
 * A data access object (DAO) providing persistence and search support for
 * Formapagament entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see com.selya.store.persistance.Formapagament
 * @author MyEclipse Persistence Tools
 */

public class FormapagamentDAO extends BaseHibernateDAO {
	private static final Logger log = Logger
			.getLogger(FormapagamentDAO.class);
	// property constants
	public static final String DESCRIPCIO = "descripcio";

	public void save(Formapagament transientInstance) {
		log.debug("saving Formapagament instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().saveOrUpdate(transientInstance);
			tx.commit();
			getSession().close();
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(Formapagament persistentInstance) {
		log.debug("deleting Formapagament instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().delete(persistentInstance);
			tx.commit();
			getSession().close();
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public Formapagament findById(java.lang.Integer id) {
		log.debug("getting Formapagament instance with id: " + id);
		try {
			Formapagament instance = (Formapagament) getSession().get(
					"com.selya.store.persistance.Formapagament", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List<Formapagament> findByExample(Formapagament instance) {
		log.debug("finding Formapagament instance by example");
		try {
			List<Formapagament> results = (List<Formapagament>) getSession()
					.createCriteria("com.selya.store.persistance.Formapagament")
					.add(create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding Formapagament instance with property: "
				+ propertyName + ", value: " + value);
		try {
			String queryString = "from Formapagament as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List<Formapagament> findByDescripcio(Object descripcio) {
		return findByProperty(DESCRIPCIO, descripcio);
	}

	public List findAll() {
		log.debug("finding all Formapagament instances");
		try {
			String queryString = "from Formapagament";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public Formapagament merge(Formapagament detachedInstance) {
		log.debug("merging Formapagament instance");
		try {
			Formapagament result = (Formapagament) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(Formapagament instance) {
		log.debug("attaching dirty Formapagament instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(Formapagament instance) {
		log.debug("attaching clean Formapagament instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}