package com.selya.store.persistance;

import java.util.List;

import org.apache.log4j.Logger;
import org.hibernate.Query;
import org.hibernate.Transaction;

public class NoticiesDAO extends BaseHibernateDAO {
	private static final Logger log = Logger.getLogger(NoticiesDAO.class);
	
	public void save(Noticies transientInstance) {
		log.debug("saving Noticies instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().saveOrUpdate(transientInstance);
			tx.commit();
			getSession().close();
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}
	
	public void delete(Noticies persistentInstance) {
		log.debug("deleting Noticies instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().delete(persistentInstance);
			tx.commit();
			getSession().close();
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public Noticies findById(int id) {
		log.debug("getting Noticies instance with id: " + id);
		try {
			getSession().clear();
			Noticies instance = (Noticies) getSession().get(
					"com.selya.store.persistance.Noticies", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<Noticies> findByProperty(String propertyName, Object value) {
		log.debug("finding Noticies instance with property: " + propertyName
				+ ", value: " + value);
		try {
			getSession().clear();
			String queryString = "from Noticies as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<Noticies> findAll() {
		log.debug("finding all Noticies instances");
		try {
			getSession().clear();
			String queryString = "from Noticies";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<Noticies> lastNews() {
		log.debug("finding six newest Noticies instances");
		try {
			String queryString = "from Noticies order by data desc limit 6";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find newest failed", re);
			throw re;
		}
	}
}
