package com.selya.store.persistance;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;
import javax.persistence.UniqueConstraint;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.log4j.Logger;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import com.selya.store.global.utils.Globals;

/**
 * Producte entity. @author MyEclipse Persistence Tools
 */
@Entity
@Table(name = "producte", catalog = "tfc", uniqueConstraints = @UniqueConstraint(columnNames = "Ref"))
public class Producte implements java.io.Serializable {
	
	protected Logger logger = Logger.getLogger(this.getClass().getName());

	// Fields

	private long id;
	private Categories categories;
	private Producte producte;
	private String ref;
	private String titol;
	private String descripcio;
	private float preu;
	private Integer stock;
	private String imatge1;
	private String imatge2;
	private String imatge3;
	private Date data;
	private Set<Wishlist> wishlists = new HashSet<Wishlist>(0);
	private Set<Carretoproducte> carretoproductes = new HashSet<Carretoproducte>(
			0);
	private Set<Productepromocio> productepromocios = new HashSet<Productepromocio>(
			0);
	private Set<Productecolor> productecolors = new HashSet<Productecolor>(0);
	private Set<Comentaris> comentaris = new HashSet<Comentaris>(0);
	private Set<Valoracio> valoracios = new HashSet<Valoracio>(0);
	private Set<Producte> productes = new HashSet<Producte>(0);
	private int pes;

	// Constructors

	/** default constructor */
	public Producte() {
	}

	/** minimal constructor */
	public Producte(long id, Categories categories, String ref, String titol,
			String descripcio, float preu, Integer stock, String imatge1,
			Date data) {
		this.id = id;
		this.categories = categories;
		this.ref = ref;
		this.titol = titol;
		this.descripcio = descripcio;
		this.preu = preu;
		this.stock = stock;
		this.imatge1 = imatge1;
		this.data = data;
	}

	/** full constructor */
	public Producte(long id, Categories categories, Producte producte,
			String ref, String titol, String descripcio, float preu,
			Integer stock, String imatge1, String imatge2, String imatge3,
			Date data, Set<Wishlist> wishlists, Set<Carretoproducte> carretoproductes,
			Set<Productepromocio> productepromocios,
			Set<Productecolor> productecolors, Set<Comentaris> comentaris,
			Set<Valoracio> valoracios, Set<Producte> productes) {
		this.id = id;
		this.categories = categories;
		this.producte = producte;
		this.ref = ref;
		this.titol = titol;
		this.descripcio = descripcio;
		this.preu = preu;
		this.stock = stock;
		this.imatge1 = imatge1;
		this.imatge2 = imatge2;
		this.imatge3 = imatge3;
		this.data = data;
		this.wishlists = wishlists;
		this.carretoproductes = carretoproductes;
		this.productepromocios = productepromocios;
		this.productecolors = productecolors;
		this.comentaris = comentaris;
		this.valoracios = valoracios;
		this.productes = productes;
	}

	// Property accessors
	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "Id", unique = true, nullable = false)
	public long getId() {
		return this.id;
	}

	public void setId(long id) {
		this.id = id;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "CategoriaId", nullable = false)
	public Categories getCategories() {
		return this.categories;
	}

	public void setCategories(Categories categories) {
		this.categories = categories;
	}

	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumn(name = "ProducteId")
	public Producte getProducte() {
		return this.producte;
	}

	public void setProducte(Producte producte) {
		this.producte = producte;
	}

	@Column(name = "Ref", unique = true, nullable = false, length = 10)
	public String getRef() {
		return this.ref;
	}

	public void setRef(String ref) {
		this.ref = ref;
	}

	@Column(name = "Titol", nullable = false, length = 65535)
	public String getTitol() {
		return titol;
	}

	public void setTitol(String titol) {
		this.titol = titol;
	}

	@Column(name = "Descripcio", nullable = false, length = 65535)
	public String getDescripcio() {
		return descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	@Column(name = "Preu", nullable = false, precision = 12, scale = 0)
	public float getPreu() {
		return this.preu;
	}

	public void setPreu(float preu) {
		this.preu = preu;
	}

	@Column(name = "Stock", nullable = false)
	public Integer getStock() {
		return this.stock;
	}

	public void setStock(Integer stock) {
		this.stock = stock;
	}

	@Column(name = "Imatge1", nullable = false)
	public String getImatge1() {
		return this.imatge1;
	}

	public void setImatge1(String imatge1) {
		this.imatge1 = imatge1;
	}

	@Column(name = "Imatge2")
	public String getImatge2() {
		return this.imatge2;
	}

	public void setImatge2(String imatge2) {
		this.imatge2 = imatge2;
	}

	@Column(name = "Imatge3")
	public String getImatge3() {
		return this.imatge3;
	}

	public void setImatge3(String imatge3) {
		this.imatge3 = imatge3;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "Data", nullable = false, length = 10)
	public Date getData() {
		return this.data;
	}

	public void setData(Date data) {
		this.data = data;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY, mappedBy = "producte")
	public Set<Wishlist> getWishlists() {
		return this.wishlists;
	}

	public void setWishlists(Set<Wishlist> wishlists) {
		this.wishlists = wishlists;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY, mappedBy = "producte")
	public Set<Carretoproducte> getCarretoproductes() {
		return this.carretoproductes;
	}

	public void setCarretoproductes(Set<Carretoproducte> carretoproductes) {
		this.carretoproductes = carretoproductes;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "producte")
	public Set<Productepromocio> getProductepromocios() {
		return this.productepromocios;
	}

	public void setProductepromocios(Set<Productepromocio> productepromocios) {
		this.productepromocios = productepromocios;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "producte")
	
	public Set<Productecolor> getProductecolors() {
		return this.productecolors;
	}

	public void setProductecolors(Set<Productecolor> productecolors) {
		this.productecolors = productecolors;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "producte")
	public Set<Comentaris> getComentaris() {
		return this.comentaris;
	}

	public void setComentaris(Set<Comentaris> comentaris) {
		this.comentaris = comentaris;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY, mappedBy = "producte")
	public Set<Valoracio> getValoracios() {
		return this.valoracios;
	}

	public void setValoracios(Set<Valoracio> valoracios) {
		this.valoracios = valoracios;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY, mappedBy = "producte")
	public Set<Producte> getProductes() {
		return this.productes;
	}

	public void setProductes(Set<Producte> productes) {
		this.productes = productes;
	}
	
	/**
	 * Métode que retorna el <code>Set</code> de <code>Color</code> com a <code>List</code>
	 * @return
	 */
	public List<Color> processListColors(){
		List<Color> colors = new ArrayList<Color>();
		
		Set<Productecolor> setColors = getProductecolors();
		Iterator<Productecolor> it = setColors.iterator();
		while(it.hasNext()){
			colors.add(it.next().getColor());
		}
		
		return colors;
	}
	
	/**
	 * Mètode que retorna la descripció del producte per l'idioma passat
	 * @param language
	 * @return
	 */
	public String getDescripcio(String language){
		
		if (this.descripcio != null && !this.descripcio.equals("")) {
			String nombre=null;
			try {
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				DocumentBuilder db = dbf.newDocumentBuilder();
			    InputSource is = new InputSource();
			    is.setCharacterStream(new StringReader(this.descripcio));
			    Document doc = db.parse(is);
				NodeList nodeLst = doc.getElementsByTagName("data");
				for (int s = 0; s < nodeLst.getLength(); s++) {

				    Node fstNode = nodeLst.item(s);
				    
				    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
				  
				      Element fstElmnt = (Element) fstNode;
				      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("language");
				      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
				      NodeList fstNm = fstNmElmnt.getChildNodes();
				      if (fstNm.item(0).getNodeValue().equals(language)) {
				    	  NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("content"); 
				    	  Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
					      NodeList lstNm = lstNmElmnt.getChildNodes();
					      nombre = ((Node) lstNm.item(0)).getNodeValue();
				      }
				    }

				  }
			} catch (SAXException e) {
				logger.error(e.getMessage(),e);
			} catch (IOException e) {
				logger.error(e.getMessage(),e);
			} catch (ParserConfigurationException e) {
				logger.error(e.getMessage(),e);
			} catch (Exception e) {
				logger.error(e.getMessage(),e);
			}
			return nombre;
		}
		else {
			return "";
		}
	}
	
	/**
	 * Métode que retorna el títol en l'idioma passat epr paràmetre
	 * @param language
	 * @return
	 */
	public String getTitol(String language){
		
		if (this.titol != null && !this.titol.equals("")) {
			String nombre=null;
			try {
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				DocumentBuilder db = dbf.newDocumentBuilder();
			    InputSource is = new InputSource();
			    is.setCharacterStream(new StringReader(titol));
			    Document doc = db.parse(is);
				NodeList nodeLst = doc.getElementsByTagName("data");
				for (int s = 0; s < nodeLst.getLength(); s++) {

				    Node fstNode = nodeLst.item(s);
				    
				    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
				  
				      Element fstElmnt = (Element) fstNode;
				      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("language");
				      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
				      NodeList fstNm = fstNmElmnt.getChildNodes();
				      if (fstNm.item(0).getNodeValue().equals(language)) {
				    	  NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("content"); 
				    	  Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
					      NodeList lstNm = lstNmElmnt.getChildNodes();
					      nombre = ((Node) lstNm.item(0)).getNodeValue();
				      }
				    }

				  }
			} catch (SAXException e) {
				logger.error(e.getMessage(),e);
			} catch (IOException e) {
				logger.error(e.getMessage(),e);
			} catch (ParserConfigurationException e) {
				logger.error(e.getMessage(),e);
			} catch (Exception e) {
				logger.error(e.getMessage(),e);
			}
			return nombre;
			
		}
		else {
			return "";
		}
	}
	
	/**
	 * Mètode que assigna la descripció per aml'idioma passat per paràmetre al producte
	 * @param language
	 * @param descripcio
	 */
	public void setDescripcio(String language, String descripcio){
		
		if (this.descripcio != null && !this.descripcio.equals("")) {
			try {
				boolean idiomaFinded = false;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				DocumentBuilder db = dbf.newDocumentBuilder();
			    InputSource is = new InputSource();
			    is.setCharacterStream(new StringReader(this.descripcio));
			    Document doc = db.parse(is);
				NodeList nodeLst = doc.getElementsByTagName("data");
				for (int s = 0; s < nodeLst.getLength(); s++) {

				    Node fstNode = nodeLst.item(s);
				    
				    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
				  
				      Element fstElmnt = (Element) fstNode;
				      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("language");
				      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
				      NodeList fstNm = fstNmElmnt.getChildNodes();
				      if (fstNm.item(0).getNodeValue().equals(language)) {
				    	  idiomaFinded = true;
				    	  NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("content"); 
				    	  Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
					      NodeList lstNm = lstNmElmnt.getChildNodes();
					      ((Node) lstNm.item(0)).setNodeValue(descripcio);
				      }
				    }

				  }
				if(!idiomaFinded){
					 StringBuffer sb = new StringBuffer(this.descripcio);
					 int ix = sb.indexOf("</data>");
					 sb.insert(ix+7, Globals.setDataTag(descripcio, language));
					 this.descripcio = sb.toString();
			      }else{
			    	  Source source = new DOMSource(doc);
			    	  StringWriter stringWriter = new StringWriter();
			    	  Result result = new StreamResult(stringWriter);
			    	  TransformerFactory factory = TransformerFactory.newInstance();
			    	  Transformer transformer = factory.newTransformer();
			    	  transformer.transform(source, result);
			    	  this.descripcio = stringWriter.getBuffer().toString();
			      }
			} catch (SAXException e) {
				logger.error(e.getMessage(),e);
			} catch (IOException e) {
				logger.error(e.getMessage(),e);
			} catch (ParserConfigurationException e) {
				logger.error(e.getMessage(),e);
			} catch (Exception e) {
				logger.error(e.getMessage(),e);
			}
		}
		else {
			StringBuffer sb = new StringBuffer(10);
			sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			sb.append("<root>");
			sb.append(Globals.setDataTag(descripcio, language));
			sb.append("</root>");
			this.descripcio = sb.toString();
		}
	}
	
	/**
	 * Mètode que assigna el títol per amb l'idioma passat per paràmetre al producte
	 * @param language
	 * @param titol
	 */
	public void setTitol(String language, String titol){
		
		if (this.titol != null && !this.titol.equals("")) {
			try {
				boolean idiomaFinded = false;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				DocumentBuilder db = dbf.newDocumentBuilder();
			    InputSource is = new InputSource();
			    is.setCharacterStream(new StringReader(this.titol));
			    Document doc = db.parse(is);
				NodeList nodeLst = doc.getElementsByTagName("data");
				for (int s = 0; s < nodeLst.getLength(); s++) {

				    Node fstNode = nodeLst.item(s);
				    
				    if (fstNode.getNodeType() == Node.ELEMENT_NODE) {
				  
				      Element fstElmnt = (Element) fstNode;
				      NodeList fstNmElmntLst = fstElmnt.getElementsByTagName("language");
				      Element fstNmElmnt = (Element) fstNmElmntLst.item(0);
				      NodeList fstNm = fstNmElmnt.getChildNodes();
				      if (fstNm.item(0).getNodeValue().equals(language)) {
				    	  idiomaFinded = true;
				    	  NodeList lstNmElmntLst = fstElmnt.getElementsByTagName("content"); 
				    	  Element lstNmElmnt = (Element) lstNmElmntLst.item(0);
					      NodeList lstNm = lstNmElmnt.getChildNodes();
					      ((Node) lstNm.item(0)).setNodeValue(titol);
				      }
				    }

				  }
				  if(!idiomaFinded){
					  StringBuffer sb = new StringBuffer(this.titol);
					  int ix = sb.indexOf("</data>");
					  sb.insert(ix+7, Globals.setDataTag(titol, language));
					  this.titol = sb.toString();
			      }else{
			    	  Source source = new DOMSource(doc);
			    	  StringWriter stringWriter = new StringWriter();
			    	  Result result = new StreamResult(stringWriter);
			    	  TransformerFactory factory = TransformerFactory.newInstance();
			    	  Transformer transformer = factory.newTransformer();
			    	  transformer.transform(source, result);
			    	  this.titol = stringWriter.getBuffer().toString();
			      }
			} catch (SAXException e) {
				logger.error(e.getMessage(),e);
			} catch (IOException e) {
				logger.error(e.getMessage(),e);
			} catch (ParserConfigurationException e) {
				logger.error(e.getMessage(),e);
			} catch (Exception e) {
				logger.error(e.getMessage(),e);
			}
		}
		else {
			StringBuffer sb = new StringBuffer(10);
			sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
			sb.append("<root>");
			sb.append(Globals.setDataTag(titol, language));
			sb.append("</root>");
			this.titol = sb.toString();
		}
	}
	
	@Transient
	public float preuPromocionat(Date data){
		Iterator<Productepromocio> it = productepromocios.iterator();
		while(it.hasNext()){
			Productepromocio pp = it.next();
			if(data.before(pp.getPromocio().getDataFi()) && data.after(pp.getPromocio().getDataInici())){
				return preu * (1-(pp.getPromocio().getPercentatge()/100));
			}
		}
		return preu;
	}
	
	@Transient
	public float preuPromocionat(){
		Date data = new Date();
		Iterator<Productepromocio> it = productepromocios.iterator();
		while(it.hasNext()){
			Productepromocio pp = it.next();
			if(data.before(pp.getPromocio().getDataFi()) && data.after(pp.getPromocio().getDataInici())){
				return preu * (1-(pp.getPromocio().getPercentatge()/100));
			}
		}
		return preu;
	}
	
	@Transient
	public boolean isPromocionat(){
		Iterator<Productepromocio> it = productepromocios.iterator();
		Date today = new Date();
		while(it.hasNext()){
			Productepromocio pp = it.next();
			if(today.before(pp.getPromocio().getDataFi()) && today.after(pp.getPromocio().getDataInici())){
				return true;
			}
		}
		return false;
	}

	@Column(name = "Pes", nullable = false)
	public int getPes() {
		return pes;
	}

	public void setPes(int pes) {
		this.pes = pes;
	}
	
	@Transient
	public int getValoracio(){
		int nVals = valoracios.size();
		if(nVals > 0){
			int total = 0;
			Iterator<Valoracio> it = valoracios.iterator();
			while(it.hasNext())
				total += it.next().getPuntuacio();
			return Math.round(total/nVals);
		}
		return 0;
	}
}