package com.selya.store.persistance;

import java.util.Date;
import java.util.Iterator;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.Transaction;

import static org.hibernate.criterion.Example.create;
import org.apache.log4j.Logger;


/**
 * A data access object (DAO) providing persistence and search support for
 * Productepromocio entities. Transaction control of the save(), update() and
 * delete() operations can directly support Spring container-managed
 * transactions or they can be augmented to handle user-managed Spring
 * transactions. Each of these methods provides additional information for how
 * to configure it for the desired type of transaction control.
 * 
 * @see com.selya.store.persistance.Productepromocio
 * @author MyEclipse Persistence Tools
 */

public class ProductepromocioDAO extends BaseHibernateDAO {
	private static final Logger log = Logger
			.getLogger(ProductepromocioDAO.class);

	// property constants

	public void save(Productepromocio transientInstance) {
		log.debug("saving Productepromocio instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().saveOrUpdate(transientInstance);
			tx.commit();
			getSession().close();
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(Productepromocio persistentInstance) {
		log.debug("deleting Productepromocio instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().delete(persistentInstance);
			tx.commit();
			getSession().close();
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public Productepromocio findById(
			com.selya.store.persistance.ProductepromocioId id) {
		log.debug("getting Productepromocio instance with id: " + id);
		try {
			getSession().clear();
			Productepromocio instance = (Productepromocio) getSession().get(
					"com.selya.store.persistance.Productepromocio", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List<Productepromocio> findByExample(Productepromocio instance) {
		log.debug("finding Productepromocio instance by example");
		try {
			getSession().clear();
			List<Productepromocio> results = (List<Productepromocio>) getSession()
					.createCriteria(
							"com.selya.store.persistance.Productepromocio")
					.add(create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding Productepromocio instance with property: "
				+ propertyName + ", value: " + value);
		try {
			getSession().clear();
			String queryString = "from Productepromocio as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List findAll() {
		log.debug("finding all Productepromocio instances");
		try {
			getSession().clear();
			String queryString = "from Productepromocio";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public Productepromocio merge(Productepromocio detachedInstance) {
		log.debug("merging Productepromocio instance");
		try {
			Productepromocio result = (Productepromocio) getSession().merge(
					detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(Productepromocio instance) {
		log.debug("attaching dirty Productepromocio instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(Productepromocio instance) {
		log.debug("attaching clean Productepromocio instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
	
	public Promocio promocioActiva(long producteId, Date data){
		List<Productepromocio> promocions = findByProperty("producteId", producteId);
		Iterator<Productepromocio> it = promocions.iterator();
		while(it.hasNext()){
			Promocio promocio = it.next().getPromocio();
			if(promocio.isActive(data))
				return promocio;
		}
		return null;
	}
	
	public void deleteProductePromocio(float producteId){
		log.debug("delete colors fron the product with Id");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().createQuery("delete from Productepromocio where producteId = :productId")
		    .setParameter("productId", producteId)
		    .executeUpdate();
			tx.commit();
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}
}