package com.selya.store.persistance;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Promocio entity. @author MyEclipse Persistence Tools
 */
@Entity
@Table(name = "promocio", catalog = "tfc")
public class Promocio implements java.io.Serializable {

	// Fields

	private Integer id;
	private float percentatge;
	private Date dataInici;
	private Date dataFi;
	private String descripcio;
	private Set<Productepromocio> productepromocios = new HashSet<Productepromocio>(
			0);

	// Constructors

	/** default constructor */
	public Promocio() {
	}

	/** minimal constructor */
	public Promocio(float percentatge, Date dataInici, Date dataFi,
			String descripcio) {
		this.percentatge = percentatge;
		this.dataInici = dataInici;
		this.dataFi = dataFi;
		this.descripcio = descripcio;
	}

	/** full constructor */
	public Promocio(float percentatge, Date dataInici, Date dataFi,
			String descripcio, Set<Productepromocio> productepromocios) {
		this.percentatge = percentatge;
		this.dataInici = dataInici;
		this.dataFi = dataFi;
		this.descripcio = descripcio;
		this.productepromocios = productepromocios;
	}

	// Property accessors
	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "Id", unique = true, nullable = false)
	public Integer getId() {
		return this.id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	@Column(name = "Percentatge", nullable = false, precision = 12, scale = 0)
	public float getPercentatge() {
		return this.percentatge;
	}

	public void setPercentatge(float percentatge) {
		this.percentatge = percentatge;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "DataInici", nullable = false, length = 10)
	public Date getDataInici() {
		return this.dataInici;
	}

	public void setDataInici(Date dataInici) {
		this.dataInici = dataInici;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "DataFi", nullable = false, length = 10)
	public Date getDataFi() {
		return this.dataFi;
	}

	public void setDataFi(Date dataFi) {
		this.dataFi = dataFi;
	}

	@Column(name = "Descripcio", nullable = false, length = 65535)
	public String getDescripcio() {
		return this.descripcio;
	}

	public void setDescripcio(String descripcio) {
		this.descripcio = descripcio;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY, mappedBy = "promocio")
	public Set<Productepromocio> getProductepromocios() {
		return this.productepromocios;
	}

	public void setProductepromocios(Set<Productepromocio> productepromocios) {
		this.productepromocios = productepromocios;
	}
	
	/**
	 * Mètode que retorna si la promoció està activa
	 * @return
	 */
	public boolean isActive(Date data){
		if(data.compareTo(dataInici) >= 0 && data.compareTo(dataFi) <= 0){
			return true;
		}
		return false;
	}

}