package com.selya.store.persistance;

import java.util.Date;
import java.util.List;
import java.util.Set;
import org.hibernate.LockMode;
import org.hibernate.Query;
import org.hibernate.Transaction;

import static org.hibernate.criterion.Example.create;
import org.apache.log4j.Logger;


/**
 * A data access object (DAO) providing persistence and search support for
 * Promocio entities. Transaction control of the save(), update() and delete()
 * operations can directly support Spring container-managed transactions or they
 * can be augmented to handle user-managed Spring transactions. Each of these
 * methods provides additional information for how to configure it for the
 * desired type of transaction control.
 * 
 * @see com.selya.store.persistance.Promocio
 * @author MyEclipse Persistence Tools
 */

public class PromocioDAO extends BaseHibernateDAO {
	private static final Logger log = Logger
			.getLogger(PromocioDAO.class);
	// property constants
	public static final String PERCENTATGE = "percentatge";
	public static final String DESCRIPCIO = "descripcio";

	public void save(Promocio transientInstance) {
		log.debug("saving Promocio instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().saveOrUpdate(transientInstance);
			tx.commit();
			getSession().close();
			log.debug("save successful");
		} catch (RuntimeException re) {
			log.error("save failed", re);
			throw re;
		}
	}

	public void delete(Promocio persistentInstance) {
		log.debug("deleting Promocio instance");
		try {
			Transaction tx = getSession().beginTransaction();
			getSession().delete(persistentInstance);
			tx.commit();
			getSession().close();
			log.debug("delete successful");
		} catch (RuntimeException re) {
			log.error("delete failed", re);
			throw re;
		}
	}

	public Promocio findById(java.lang.Integer id) {
		log.debug("getting Promocio instance with id: " + id);
		try {
			getSession().clear();
			Promocio instance = (Promocio) getSession().get(
					"com.selya.store.persistance.Promocio", id);
			return instance;
		} catch (RuntimeException re) {
			log.error("get failed", re);
			throw re;
		}
	}

	public List<Promocio> findByExample(Promocio instance) {
		log.debug("finding Promocio instance by example");
		try {
			getSession().clear();
			List<Promocio> results = (List<Promocio>) getSession()
					.createCriteria("com.selya.store.persistance.Promocio")
					.add(create(instance)).list();
			log.debug("find by example successful, result size: "
					+ results.size());
			return results;
		} catch (RuntimeException re) {
			log.error("find by example failed", re);
			throw re;
		}
	}

	public List findByProperty(String propertyName, Object value) {
		log.debug("finding Promocio instance with property: " + propertyName
				+ ", value: " + value);
		try {
			getSession().clear();
			String queryString = "from Promocio as model where model."
					+ propertyName + "= ?";
			Query queryObject = getSession().createQuery(queryString);
			queryObject.setParameter(0, value);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find by property name failed", re);
			throw re;
		}
	}

	public List<Promocio> findByPercentatge(Object percentatge) {
		return findByProperty(PERCENTATGE, percentatge);
	}

	public List<Promocio> findByDescripcio(Object descripcio) {
		return findByProperty(DESCRIPCIO, descripcio);
	}

	public List findAll() {
		log.debug("finding all Promocio instances");
		try {
			getSession().clear();
			String queryString = "from Promocio";
			Query queryObject = getSession().createQuery(queryString);
			return queryObject.list();
		} catch (RuntimeException re) {
			log.error("find all failed", re);
			throw re;
		}
	}

	public Promocio merge(Promocio detachedInstance) {
		log.debug("merging Promocio instance");
		try {
			Promocio result = (Promocio) getSession().merge(detachedInstance);
			log.debug("merge successful");
			return result;
		} catch (RuntimeException re) {
			log.error("merge failed", re);
			throw re;
		}
	}

	public void attachDirty(Promocio instance) {
		log.debug("attaching dirty Promocio instance");
		try {
			getSession().saveOrUpdate(instance);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}

	public void attachClean(Promocio instance) {
		log.debug("attaching clean Promocio instance");
		try {
			getSession().lock(instance, LockMode.NONE);
			log.debug("attach successful");
		} catch (RuntimeException re) {
			log.error("attach failed", re);
			throw re;
		}
	}
}