package com.selya.store.persistance;

import java.util.HashSet;
import java.util.Set;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import static javax.persistence.GenerationType.IDENTITY;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 * Usuaris entity. @author MyEclipse Persistence Tools
 */
@Entity
@Table(name = "usuaris", catalog = "tfc", uniqueConstraints = {
		@UniqueConstraint(columnNames = "Usuari"),
		@UniqueConstraint(columnNames = "Email") })
public class Usuaris implements java.io.Serializable {

	// Fields

	private long id;
	private Paisos paisos;
	private String nom;
	private String cognom1;
	private String cognom2;
	private String carrer;
	private String cp;
	private String poblacio;
	private String provincia;
	private String usuari;
	private String psw;
	private String email;
	private String telefon;
	private String dni;
	private int admin;
	private Set<Wishlist> wishlists = new HashSet<Wishlist>(0);
	private Set<Carreto> carretos = new HashSet<Carreto>(0);

	// Constructors

	/** default constructor */
	public Usuaris() {
	}

	/** minimal constructor */
	public Usuaris(Paisos paisos, String nom, String cognom1, String cognom2,
			String carrer, String cp, String poblacio, String provincia,
			String usuari, String psw, String email, int admin) {
		this.paisos = paisos;
		this.nom = nom;
		this.cognom1 = cognom1;
		this.cognom2 = cognom2;
		this.carrer = carrer;
		this.cp = cp;
		this.poblacio = poblacio;
		this.provincia = provincia;
		this.usuari = usuari;
		this.psw = psw;
		this.email = email;
		this.admin = admin;
	}

	/** full constructor */
	public Usuaris(Paisos paisos, String nom, String cognom1, String cognom2,
			String carrer, String cp, String poblacio, String provincia,
			String usuari, String psw, String email, String telefon,
			int admin, Set<Wishlist> wishlists,
			Set<Carreto> carretousuaris) {
		this.paisos = paisos;
		this.nom = nom;
		this.cognom1 = cognom1;
		this.cognom2 = cognom2;
		this.carrer = carrer;
		this.cp = cp;
		this.poblacio = poblacio;
		this.provincia = provincia;
		this.usuari = usuari;
		this.psw = psw;
		this.email = email;
		this.telefon = telefon;
		this.admin = admin;
		this.wishlists = wishlists;
		this.carretos = carretousuaris;
	}

	// Property accessors
	@Id
	@GeneratedValue(strategy = IDENTITY)
	@Column(name = "Id", unique = true, nullable = false)
	public long getId() {
		return this.id;
	}

	public void setId(long id) {
		this.id = id;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "Pais", nullable = false)
	public Paisos getPaisos() {
		return this.paisos;
	}

	public void setPaisos(Paisos paisos) {
		this.paisos = paisos;
	}

	@Column(name = "Nom", nullable = false, length = 100)
	public String getNom() {
		return this.nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	@Column(name = "Cognom1", nullable = false, length = 100)
	public String getCognom1() {
		return this.cognom1;
	}

	public void setCognom1(String cognom1) {
		this.cognom1 = cognom1;
	}

	@Column(name = "Cognom2", nullable = false, length = 100)
	public String getCognom2() {
		return this.cognom2;
	}

	public void setCognom2(String cognom2) {
		this.cognom2 = cognom2;
	}

	@Column(name = "Carrer", nullable = false)
	public String getCarrer() {
		return this.carrer;
	}

	public void setCarrer(String carrer) {
		this.carrer = carrer;
	}

	@Column(name = "CP", nullable = false, length = 10)
	public String getCp() {
		return this.cp;
	}

	public void setCp(String cp) {
		this.cp = cp;
	}

	@Column(name = "Poblacio", nullable = false, length = 100)
	public String getPoblacio() {
		return this.poblacio;
	}

	public void setPoblacio(String poblacio) {
		this.poblacio = poblacio;
	}

	@Column(name = "Provincia", nullable = false, length = 100)
	public String getProvincia() {
		return this.provincia;
	}

	public void setProvincia(String provincia) {
		this.provincia = provincia;
	}

	@Column(name = "Usuari", unique = true, nullable = false, length = 45)
	public String getUsuari() {
		return this.usuari;
	}

	public void setUsuari(String usuari) {
		this.usuari = usuari;
	}

	@Column(name = "Psw", nullable = false)
	public String getPsw() {
		return this.psw;
	}

	public void setPsw(String psw) {
		this.psw = psw;
	}

	@Column(name = "Email", unique = true, nullable = false, length = 100)
	public String getEmail() {
		return this.email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	@Column(name = "Telefon", length = 15)
	public String getTelefon() {
		return this.telefon;
	}

	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}

	@Column(name = "Admin", nullable = false)
	public int getAdmin() {
		return this.admin;
	}

	public void setAdmin(int admin) {
		this.admin = admin;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "usuaris")
	public Set<Wishlist> getWishlists() {
		return this.wishlists;
	}

	public void setWishlists(Set<Wishlist> wishlists) {
		this.wishlists = wishlists;
	}

	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER, mappedBy = "usuaris")
	public Set<Carreto> getCarretos() {
		return this.carretos;
	}

	public void setCarretos(Set<Carreto> carretos) {
		this.carretos = carretos;
	}

	@Column(name = "DNI", length = 15, nullable = false, unique = true)
	public String getDni() {
		return dni;
	}

	public void setDni(String dni) {
		this.dni = dni;
	}

}