package com.selya.store.servlets;

import java.io.IOException;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.json.JSONObject;

import org.apache.log4j.Logger;

import com.selya.store.persistance.Carreto;
import com.selya.store.persistance.CarretoDAO;
import com.selya.store.persistance.Carretoproducte;
import com.selya.store.persistance.CarretoproducteDAO;
import com.selya.store.persistance.CarretoproducteId;
import com.selya.store.persistance.Color;
import com.selya.store.persistance.ColorDAO;
import com.selya.store.persistance.Producte;
import com.selya.store.persistance.ProducteDAO;
import com.selya.store.persistance.Usuaris;

public class AddProductCarretoServlet extends HttpServlet {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 3664763523823482905L;
	private Logger logger = Logger.getLogger(this.getClass().getName());
	private static final String USUARI = "user";
	private static final String PRODUCTE = "producteId";
	private static final String COLOR = "color";
	private static final String QUANTITAT = "quantitat";
	private static final String MIDA = "mida";
	private static final String CARRETO = "carreto";
	
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) {
		CarretoDAO carretoDAO = new CarretoDAO();
		Carreto carreto = (Carreto) req.getSession().getAttribute(CARRETO);
		ProducteDAO pDAO = new ProducteDAO();
		Producte producte = pDAO.findById(Long.parseLong(req.getParameter(PRODUCTE)));
		ColorDAO cDAO = new ColorDAO();
		Color color = cDAO.findById(Integer.parseInt(req.getParameter(COLOR)));
		String mida = req.getParameter(MIDA);
		int quantitat = Integer.parseInt(req.getParameter(QUANTITAT));
		
		CarretoproducteDAO cpDAO = new CarretoproducteDAO();
		Carretoproducte cp = null;
		
		try{
			cp = cpDAO.findById(new CarretoproducteId(carreto.getId(), producte.getId()));
			if(cp == null){
				cp = new Carretoproducte();
				cp.setId(new CarretoproducteId(carreto.getId(), producte.getId()));
			}
		}catch(RuntimeException e){
			cp = new Carretoproducte();
		}
		cp.setQuantitat(quantitat);
		cp.setCarreto(carreto);
		cp.setColor(color);
		cp.setMida(mida);
		cp.setProducte(producte);
		
		Usuaris usuari = (Usuaris) req.getSession().getAttribute(USUARI);
		if(usuari != null){
			if(carretoDAO.findById(carreto.getId()) != null){
				carreto.setUsuaris(usuari);
				carretoDAO.merge(carreto);
				cpDAO.save(cp);
			}else{
				
			}
		}
		
		carreto.getCarretoproductes().add(cp);
		req.getSession().setAttribute(CARRETO, carreto);
		
		JSONObject json = new JSONObject();
		json.put("id", producte.getId());
		json.put("ref", producte.getRef());
		json.put("titol", producte.getTitol());
		json.put("quantitat", quantitat);
		
		String result = json.toString();
		
		ServletOutputStream sos;
		try {
			sos = resp.getOutputStream();
			sos.write(result.getBytes());
			sos.flush();
		    sos.close();
		} catch (IOException e) {
			logger.error(e.getMessage(),e);
		}                
	   
	}

}
