package com.selya.store.servlets;

import java.io.IOException;
import java.util.Iterator;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import com.selya.store.persistance.ProducteDAO;
import com.selya.store.persistance.Usuaris;
import com.selya.store.persistance.Wishlist;
import com.selya.store.persistance.WishlistDAO;
import com.selya.store.persistance.WishlistId;

public class AddWishList extends HttpServlet {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1076846156835055479L;
	private Logger logger = Logger.getLogger(this.getClass().getName());
	private static final String USUARI = "user";
	private static final String PRODUCTEID = "producteId";
	
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		Usuaris usuari = (Usuaris) req.getSession().getAttribute(USUARI);
		long producteId = Long.parseLong(req.getParameter(PRODUCTEID));
		
		WishlistDAO wlDAO = new WishlistDAO();
		String msg = "";
		boolean finded = false;
		Iterator<Wishlist> it = usuari.getWishlists().iterator();
		while(it.hasNext()){
			Wishlist wl = it.next();
			if(wl.getProducte().getId() == producteId){
				finded = true;
				break;
			}
		}
		if(finded){
			msg = "KO";
		}
		else{
			Wishlist wishList = new Wishlist();
			ProducteDAO producteDAO = new ProducteDAO();
			wishList.setProducte(producteDAO.findById(producteId));
			wishList.setUsuaris(usuari);
			wishList.setId(new WishlistId(producteId, usuari.getId()));
			wlDAO.save(wishList);
			msg = "OK";
		}
		ServletOutputStream sos;
		try {
			sos = resp.getOutputStream();
			sos.write(msg.getBytes());
			sos.flush();
		    sos.close();
		} catch (IOException e) {
			logger.error(e.getMessage(),e);
		} 
	}

}
