package com.selya.store.servlets;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.json.JSONObject;

import org.apache.log4j.Logger;

import com.selya.store.persistance.Carreto;
import com.selya.store.persistance.Carretoproducte;
import com.selya.store.persistance.CarretoproducteDAO;
import com.selya.store.persistance.CarretoproducteId;
import com.selya.store.persistance.Producte;
import com.selya.store.persistance.ProducteDAO;
import com.selya.store.persistance.Usuaris;

public class RemoveProducteCarretoServlet extends HttpServlet {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -8872192906522496281L;
	private Logger logger = Logger.getLogger(this.getClass().getName());
	private static final String PRODUCTE = "producteId";
	private static final String CARRETO = "carreto";
	private static final String USUARI = "user";
	
	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		
		String producteId = req.getParameter(PRODUCTE);
		JSONObject json = new JSONObject();
		
		if(producteId != null && producteId.trim().length() > 0){
			Carreto carreto = (Carreto) req.getSession().getAttribute(CARRETO);
			ProducteDAO producteDAO = new ProducteDAO();
			Producte producte = producteDAO.findById(Long.parseLong(producteId));
			CarretoproducteDAO carretoProducteDAO = new CarretoproducteDAO();
			CarretoproducteId carretoProducteID = new CarretoproducteId(carreto.getId(), producte.getId());
			Carretoproducte carretoProducte = carretoProducteDAO.findById(carretoProducteID);
			carreto.getCarretoproductes().remove(carretoProducte);
			
			Usuaris usuari = (Usuaris) req.getSession().getAttribute(USUARI);
			if(usuari != null){
				carretoProducteDAO.delete(carretoProducte);
			}
			
			json.put("result", "success");
			json.put("productId", producteId);
		}else{
			json.put("result", "error");
		}
		
		ServletOutputStream sos;
		try {
			sos = resp.getOutputStream();
			sos.write(json.toString().getBytes());
			sos.flush();
		    sos.close();
		} catch (IOException e) {
			logger.error(e.getMessage(),e);
		}
		
	}

}
