/**
 * 
 */
package com.selya.store.test;

import static org.junit.Assert.assertTrue;

import java.io.File;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.junit.Before;
import org.junit.Test;

import com.selya.store.global.beans.Producte;
import com.selya.store.persistance.Categories;
import com.selya.store.persistance.CategoriesDAO;
import com.selya.store.persistance.Color;
import com.selya.store.persistance.ColorDAO;
import com.selya.store.persistance.ProducteDAO;
import com.selya.store.persistance.Productecolor;
import com.selya.store.persistance.ProductecolorDAO;
import com.selya.store.persistance.ProductecolorId;

/**
 * @author Daniel Martín
 *
 */
public class ProducteDBTest {
	
	private Producte producte;
	private Color color;
	private ProducteDAO pDAO;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		CategoriesDAO cDAO = new CategoriesDAO();
		cDAO.save(new Categories("collaret"));
		List<Color> colors = new ArrayList<Color>();
		color = new Color("blau");
		color.setId(1);
		colors.add(color);
		producte = new Producte(0, "PKL-123", "Titol del producte", "Descripció del producte", 15.7f, 5, new File("c:/test"), new File("c:/test"), new File("c:/test"), new Categories("Collaret"), colors, new Date());
		pDAO = new ProducteDAO();
	}

	/**
	 * Test method for {@link com.selya.store.persistance.ProducteDAO#save(com.selya.store.persistance.Producte)}.
	 */
	@Test
	public void testSave() {
		CategoriesDAO categDAO = new CategoriesDAO();
		com.selya.store.persistance.Producte producte = new com.selya.store.persistance.Producte();
		producte.setId(this.producte.getProducteId());
		producte.setRef(this.producte.getRef());
		producte.setTitol(this.producte.getTitol());
		producte.setDescripcio(this.producte.getDescripcio());
		producte.setPreu(this.producte.getPreu());
		producte.setStock(this.producte.getStock());
		producte.setImatge1(this.producte.getImage1().getAbsolutePath());
		producte.setImatge2(this.producte.getImage2().getAbsolutePath());
		producte.setImatge3(this.producte.getImage3().getAbsolutePath());
		producte.setData(new Date());
		producte.setCategories((Categories)categDAO.findAll().get(0));
		
		if(this.producte.getProducteId() > 0)
			pDAO.merge(producte);
		else
			pDAO.save(producte);
		
		ProductecolorDAO producteColorDAO = new ProductecolorDAO();
		ColorDAO cDAO = new ColorDAO();
		ProductecolorId producteColorId = null;
		cDAO.save(color);
		producteColorId = new ProductecolorId(producte.getId(), color.getId());
		Productecolor pc = new Productecolor();
		pc.setId(producteColorId);
		producteColorDAO.save(pc);
		
		assertTrue("Saving test",pDAO.findByRef("PKL-123").size()>0);
	}

	/**
	 * Test method for {@link com.selya.store.persistance.ProducteDAO#delete(com.selya.store.persistance.Producte)}.
	 */
	/*@Test
	public void testDelete() {
		fail("Not yet implemented");
	}*/

	/**
	 * Test method for {@link com.selya.store.persistance.ProducteDAO#novetats()}.
	 */
	/*@Test
	public void testNovetats() {
		fail("Not yet implemented");
	}*/

}
