/**
 * 
 */
package com.selya.store.test;

import static org.junit.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

import com.selya.store.persistance.PaisosDAO;
import com.selya.store.persistance.Usuaris;
import com.selya.store.persistance.UsuarisDAO;

/**
 * @author Daniel Martín
 *
 */
public class UsuarisDBTest {
	
	private String username;
	private String password;
	private UsuarisDAO uDAO;

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		username = "dani.martin";
		password = "d4n13l1t0";
		uDAO = new UsuarisDAO();
	}

	/**
	 * Test method for {@link com.selya.store.persistance.UsuarisDAO#save(com.selya.store.persistance.Usuaris)}.
	 */
	@Test
	public void testSave() {
		PaisosDAO pDAO = new PaisosDAO();
		Usuaris usuari = new Usuaris(pDAO.findById(1), "Pedrito", "Perico", "", "Street", "125856", "Town", "County", "pedrito", "35bc8cec895861697a0243c1304c7789", "correu@mail.com", 0);
		uDAO.save(usuari);
		
		assertTrue("Saving test",uDAO.findByUsuari("pedrito").size()>0);
	}

	/**
	 * Test method for {@link com.selya.store.persistance.UsuarisDAO#delete(com.selya.store.persistance.Usuaris)}.
	 */
	/*@Test
	public void testDelete() {
		Usuaris usuari = uDAO.findByUsuari("pedrito").get(0);
		uDAO.delete(usuari);
		assertTrue("Deleting test",uDAO.findByUsuari("pedrito").size()<1);
	}*/

	/**
	 * Test method for {@link com.selya.store.persistance.UsuarisDAO#findUsuarisByParams(java.lang.String, java.lang.String, java.lang.String, java.lang.String, java.lang.String)}.
	 */
	@Test
	public void testFindUsuarisByParams() {
		assertTrue("Find by Nom",uDAO.findUsuarisByParams("Dani", "", "", "", "").size()>0);
		assertTrue("Find By Cognom1",uDAO.findUsuarisByParams("", "Martín", "", "", "").size()>0);
		assertTrue("Find By Cognom2",uDAO.findUsuarisByParams("", "", "Valls", "", "").size()>0);
		assertTrue("Find By email",uDAO.findUsuarisByParams("", "", "", "correudeldani@gmail.com", "").size()>0);
		assertTrue("Find By username",uDAO.findUsuarisByParams("", "", "", "", "dani.martin").size()>0);
		assertTrue("Find By full params",uDAO.findUsuarisByParams("Dani", "Martín", "Valls", "correudeldani@gmail.com", "dani.martin").size()>0);
		assertTrue("Find By username not exists",uDAO.findUsuarisByParams("", "", "", "", "dmartin").size()<1);
	}

	/**
	 * Test method for {@link com.selya.store.persistance.UsuarisDAO#topCompradors(java.util.Date, java.util.Date)}.
	 */
	/*@Test
	public void testTopCompradors() {
		fail("Not yet implemented");
	}*/

	/**
	 * Test method for {@link com.selya.store.persistance.UsuarisDAO#loginUser(java.lang.String, java.lang.String)}.
	 */
	@Test
	public void testLoginUser() {
		assertTrue("No és nul", uDAO.loginUser(username, password)!=null);
	}

}
